// $ANTLR 2.7.6 (2005-12-22): "CExprEvaluator.g" -> "CExprEvaluator.java"$

// This file is part of the program FRYSK.
//
// Copyright 2005, 2007 Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    import java.util.ArrayList;
    import frysk.value.ArithmeticType;
    import frysk.value.SignedType;
    // import frysk.value.UnsignedType;
    import frysk.value.FloatingPointType;
    import frysk.value.PointerType;
    import frysk.value.CharType;
    import frysk.value.Value;
    import frysk.expr.ExprSymTab;
    import inua.eio.ByteOrder;

// import antlr.TreeParser;
// import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
// import antlr.ANTLRException;
import antlr.NoViableAltException;
// import antlr.MismatchedTokenException;
// import antlr.SemanticException;
import antlr.collections.impl.BitSet;
// import antlr.ASTPair;
// import antlr.collections.impl.ASTArray;


public class CExprEvaluator extends antlr.TreeParser       implements CExprEvaluatorTokenTypes
 {

    ArrayList      refList;
    ArithmeticType arithmeticType;
    ArithmeticType longType;
    ArithmeticType intType;
    ArithmeticType shortType;
    CharType charType;
    PointerType charPointerType;
    FloatingPointType doubleType;
    FloatingPointType floatType;
    private ExprSymTab exprSymTab;
    public CExprEvaluator(ExprSymTab symTab) {
	    exprSymTab = symTab;
        // FIXME: The ExprSymTab can provide types such as this.
        shortType = new SignedType("short", ByteOrder.LITTLE_ENDIAN, 2);
        intType = new SignedType("int", ByteOrder.LITTLE_ENDIAN, 4);
        longType = new SignedType("long", ByteOrder.LITTLE_ENDIAN, exprSymTab.getWordSize());
        floatType = new FloatingPointType("float", ByteOrder.LITTLE_ENDIAN, 4);
        doubleType = new FloatingPointType("double", ByteOrder.LITTLE_ENDIAN, 8);
        charType = new CharType("char", ByteOrder.LITTLE_ENDIAN, 1, true);
        charPointerType = new PointerType("char*", ByteOrder.LITTLE_ENDIAN, 
                                          exprSymTab.getWordSize(), charType);
    }
public CExprEvaluator() {
	tokenNames = _tokenNames;
}

	public final void primitiveType(AST _t) throws RecognitionException {
		
		// AST primitiveType_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_boolean:
			{
				// AST tmp1_AST_in = (AST)_t;
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_char:
			{
				// AST tmp2_AST_in = (AST)_t;
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_byte:
			{
				// AST tmp3_AST_in = (AST)_t;
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_short:
			{
				// AST tmp4_AST_in = (AST)_t;
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_int:
			{
				// AST tmp5_AST_in = (AST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_long:
			{
				// AST tmp6_AST_in = (AST)_t;
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_float:
			{
				// AST tmp7_AST_in = (AST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_double:
			{
				// AST tmp8_AST_in = (AST)_t;
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void typeCast(AST _t) throws RecognitionException {
		
		// AST typeCast_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		try {      // for error handling
			primitiveType(_t);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			if ((_t.getType()==STAR)) {
				// AST tmp9_AST_in = (AST)_t;
				match(_t,STAR);
				_t = _t.getNextSibling();
			}
			else if ((_tokenSet_0.member(_t.getType()))) {
			}
			else {
				throw new NoViableAltException(_t);
			}
			
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final String  identifier(AST _t) throws RecognitionException {
		String idSpelling=null;
		
		// AST identifier_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST ident = null;
		
		try {      // for error handling
			ident = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				idSpelling=ident.getText();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return idSpelling;
	}
	
	public final Value  expr(AST _t) throws RecognitionException {
		Value returnVar=null;
		
		// AST expr_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST o = null;
		AST i = null;
		AST h = null;
		AST f = null;
		AST d = null;
		AST pt = null;
		AST ident = null;
		AST tident = null;
		Value v1, v2, v3, log_expr; String s1;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PLUS:
			{
				AST __t6 = _t;
				// AST tmp10_AST_in = (AST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t6;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.add(v1, v2);  
					
				}
				break;
			}
			case PLUSEQUAL:
			{
				AST __t7 = _t;
				// AST tmp11_AST_in = (AST)_t;
				match(_t,PLUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t7;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.plusEqual(v1, v2);
					
				}
				break;
			}
			case MINUSEQUAL:
			{
				AST __t12 = _t;
				// AST tmp12_AST_in = (AST)_t;
				match(_t,MINUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t12;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(),
					exprSymTab.getWordSize())
					.minusEqual(v1, v2);
					
				}
				break;
			}
			case STAR:
			{
				AST __t17 = _t;
				// AST tmp13_AST_in = (AST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t17;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.multiply(v1, v2); 
					
				}
				break;
			}
			case TIMESEQUAL:
			{
				AST __t18 = _t;
				// AST tmp14_AST_in = (AST)_t;
				match(_t,TIMESEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t18;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.timesEqual(v1, v2);
					
				}
				break;
			}
			case DIVIDE:
			{
				AST __t19 = _t;
				// AST tmp15_AST_in = (AST)_t;
				match(_t,DIVIDE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t19;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.divide(v1, v2); 
					
				}
				break;
			}
			case DIVIDEEQUAL:
			{
				AST __t20 = _t;
				// AST tmp16_AST_in = (AST)_t;
				match(_t,DIVIDEEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t20;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.divideEqual(v1, v2);
					
				}
				break;
			}
			case MOD:
			{
				AST __t21 = _t;
				// AST tmp17_AST_in = (AST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t21;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.mod(v1, v2);  
					
				}
				break;
			}
			case MODEQUAL:
			{
				AST __t22 = _t;
				// AST tmp18_AST_in = (AST)_t;
				match(_t,MODEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t22;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.modEqual(v1, v2);
					
				}
				break;
			}
			case MEMORY:
			{
				AST __t23 = _t;
				// AST tmp19_AST_in = (AST)_t;
				match(_t,MEMORY);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t23;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType()
					.dereference(v1, exprSymTab.taskMemory());
					
				}
				break;
			}
			case SHIFTLEFT:
			{
				AST __t24 = _t;
				// AST tmp20_AST_in = (AST)_t;
				match(_t,SHIFTLEFT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t24;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.shiftLeft(v1, v2);  
					
				}
				break;
			}
			case SHIFTRIGHT:
			{
				AST __t25 = _t;
				// AST tmp21_AST_in = (AST)_t;
				match(_t,SHIFTRIGHT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t25;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.shiftRight(v1, v2); 
					
				}
				break;
			}
			case LESSTHAN:
			{
				AST __t26 = _t;
				// AST tmp22_AST_in = (AST)_t;
				match(_t,LESSTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t26;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.lessThan(v1, v2); 
					
				}
				break;
			}
			case GREATERTHAN:
			{
				AST __t27 = _t;
				// AST tmp23_AST_in = (AST)_t;
				match(_t,GREATERTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t27;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar =  v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.greaterThan(v1, v2); 
					
				}
				break;
			}
			case LESSTHANOREQUALTO:
			{
				AST __t28 = _t;
				// AST tmp24_AST_in = (AST)_t;
				match(_t,LESSTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t28;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar =  v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.lessThanOrEqualTo(v1, v2); 
					
				}
				break;
			}
			case GREATERTHANOREQUALTO:
			{
				AST __t29 = _t;
				// AST tmp25_AST_in = (AST)_t;
				match(_t,GREATERTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t29;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar =  v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.greaterThanOrEqualTo(v1, v2); 
					
				}
				break;
			}
			case NOTEQUAL:
			{
				AST __t30 = _t;
				// AST tmp26_AST_in = (AST)_t;
				match(_t,NOTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t30;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar =  v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.notEqual(v1, v2); 
					
				}
				break;
			}
			case EQUAL:
			{
				AST __t31 = _t;
				// AST tmp27_AST_in = (AST)_t;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t31;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.equal(v1, v2); 
					
				}
				break;
			}
			case AMPERSAND:
			{
				AST __t35 = _t;
				// AST tmp28_AST_in = (AST)_t;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t35;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseAnd(v1, v2); 
					
				}
				break;
			}
			case ADDRESS_OF:
			{
				AST __t36 = _t;
				// AST tmp29_AST_in = (AST)_t;
				match(_t,ADDRESS_OF);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t36;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().addressOf(v1, 
					exprSymTab.order(), exprSymTab.getWordSize());
					
				}
				break;
			}
			case BITWISEXOR:
			{
				AST __t37 = _t;
				// AST tmp30_AST_in = (AST)_t;
				match(_t,BITWISEXOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t37;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseXor(v1, v2); 
					
				}
				break;
			}
			case BITWISEOR:
			{
				AST __t38 = _t;
				// AST tmp31_AST_in = (AST)_t;
				match(_t,BITWISEOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t38;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseOr(v1, v2); 
					
				}
				break;
			}
			case AND:
			{
				AST __t39 = _t;
				// AST tmp32_AST_in = (AST)_t;
				match(_t,AND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t39;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(exprSymTab.getWordSize())
					.logicalAnd(v1, v2); 
					
				}
				break;
			}
			case OR:
			{
				AST __t40 = _t;
				// AST tmp33_AST_in = (AST)_t;
				match(_t,OR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t40;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(exprSymTab.getWordSize())
					.logicalOr(v1, v2); 
					
				}
				break;
			}
			case NOT:
			{
				AST __t41 = _t;
				// AST tmp34_AST_in = (AST)_t;
				match(_t,NOT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t41;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					// byte buffer needed for Pointer/Address types
					returnVar = v1.getType().getALU(exprSymTab.getWordSize())
					.logicalNegation(v1); 
					
				}
				break;
			}
			case TILDE:
			{
				AST __t42 = _t;
				// AST tmp35_AST_in = (AST)_t;
				match(_t,TILDE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t42;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(exprSymTab.getWordSize())
					.bitWiseComplement(v1); 
					
				}
				break;
			}
			case ARITHMETIC_PLUS:
			{
				AST __t43 = _t;
				// AST tmp36_AST_in = (AST)_t;
				match(_t,ARITHMETIC_PLUS);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t43;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1; 
					
				}
				break;
			}
			case ARITHMETIC_MINUS:
			{
				AST __t44 = _t;
				// AST tmp37_AST_in = (AST)_t;
				match(_t,ARITHMETIC_MINUS);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t44;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Value zero = longType.createValue(0);
					returnVar = v1.getType().getALU(zero.getType(), 
					exprSymTab.getWordSize())
					.subtract(zero, v1); 
					
				}
				break;
			}
			case PREINCREMENT:
			{
				AST __t45 = _t;
				// AST tmp38_AST_in = (AST)_t;
				match(_t,PREINCREMENT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t45;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Value one = longType.createValue(1);
					v1.assign(v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.add(one, v1)); 
					returnVar = v1; 
					
				}
				break;
			}
			case PREDECREMENT:
			{
				AST __t46 = _t;
				// AST tmp39_AST_in = (AST)_t;
				match(_t,PREDECREMENT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t46;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Value one = longType.createValue(1);
					v1.assign(v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.subtract(v1, one)); 
					returnVar = v1;     
					
				}
				break;
			}
			case POSTINCREMENT:
			{
				AST __t47 = _t;
				// AST tmp40_AST_in = (AST)_t;
				match(_t,POSTINCREMENT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t47;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Value one = longType.createValue(1);
					v1.assign(v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.add(one, v1)); 
					returnVar = (v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.subtract(v1, one));                      
					
				}
				break;
			}
			case POSTDECREMENT:
			{
				AST __t48 = _t;
				// AST tmp41_AST_in = (AST)_t;
				match(_t,POSTDECREMENT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t48;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Value one = longType.createValue(1);            
					v1.assign(v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.subtract(v1, one));  
					returnVar = (v1.getType().getALU(one.getType(), 
					exprSymTab.getWordSize())
					.add(v1, one));                         
					
				}
				break;
			}
			case COND_EXPR:
			{
				AST __t49 = _t;
				// AST tmp42_AST_in = (AST)_t;
				match(_t,COND_EXPR);
				_t = _t.getFirstChild();
				log_expr=expr(_t);
				_t = _retTree;
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t49;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((log_expr.getType().getALU(log_expr.getType(), 
					exprSymTab.getWordSize())
					.getLogicalValue(log_expr)) 
					? v1 : v2);
					
				}
				break;
			}
			case OCTALINT:
			{
				o = (AST)_t;
				match(_t,OCTALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = o.getText().charAt(o.getText().length() - 1);
						    int l = o.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(o.getText().substring(1, l), 8));
					
				}
				break;
			}
			case DECIMALINT:
			{
				i = (AST)_t;
				match(_t,DECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = i.getText().charAt(i.getText().length() - 1);
						    int l = i.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(i.getText().substring(0, l)));
					
				}
				break;
			}
			case HEXADECIMALINT:
			{
				h = (AST)_t;
				match(_t,HEXADECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = h.getText().charAt(h.getText().length() - 1);
						    int l = h.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(h.getText().substring(2, l), 16));
					
				}
				break;
			}
			case FLOAT:
			{
				f = (AST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = f.getText().charAt(f.getText().length() - 1);
						    int l = f.getText().length();
						    if (c == 'f' || c == 'F' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					floatType.createValue(Float.parseFloat(f.getText().substring(0, l)));
					
				}
				break;
			}
			case DOUBLE:
			{
				d = (AST)_t;
				match(_t,DOUBLE);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = d.getText().charAt(d.getText().length() - 1);
						    int l = d.getText().length();
						    if (c == 'f' || c == 'F' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					doubleType.createValue(Double.parseDouble(d.getText().substring(0, l)));
					
				}
				break;
			}
			case ASSIGNEQUAL:
			{
				AST __t50 = _t;
				// AST tmp43_AST_in = (AST)_t;
				match(_t,ASSIGNEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t50;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.assign(v2);
					returnVar = v1;
					
				}
				break;
			}
			case SHIFTLEFTEQUAL:
			{
				AST __t51 = _t;
				// AST tmp44_AST_in = (AST)_t;
				match(_t,SHIFTLEFTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t51;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.shiftLeftEqual(v1, v2);
					
				}
				break;
			}
			case SHIFTRIGHTEQUAL:
			{
				AST __t52 = _t;
				// AST tmp45_AST_in = (AST)_t;
				match(_t,SHIFTRIGHTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t52;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.shiftRightEqual(v1, v2);
					
				}
				break;
			}
			case BITWISEANDEQUAL:
			{
				AST __t53 = _t;
				// AST tmp46_AST_in = (AST)_t;
				match(_t,BITWISEANDEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t53;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseAndEqual(v1, v2);
					
					
				}
				break;
			}
			case BITWISEXOREQUAL:
			{
				AST __t54 = _t;
				// AST tmp47_AST_in = (AST)_t;
				match(_t,BITWISEXOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t54;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseXorEqual(v1, v2);
					
				}
				break;
			}
			case BITWISEOREQUAL:
			{
				AST __t55 = _t;
				// AST tmp48_AST_in = (AST)_t;
				match(_t,BITWISEOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t55;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().getALU(v2.getType(), 
					exprSymTab.getWordSize())
					.bitWiseOrEqual(v1, v2);
					
				}
				break;
			}
			case CAST:
			{
				AST __t56 = _t;
				// AST tmp49_AST_in = (AST)_t;
				match(_t,CAST);
				_t = _t.getFirstChild();
				pt = _t==ASTNULL ? null : (AST)_t;
				typeCast(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t56;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						         
						    if(pt.getText().compareTo("long") == 0) {
						      returnVar = longType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("int") == 0) {
						      returnVar = intType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("short") == 0) {
						      returnVar = shortType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("double") == 0) {
						      returnVar = doubleType.createValue(0.0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("float") == 0) {
						      returnVar = floatType.createValue(0.0);
					returnVar.assign(v2);
						      }
						    // XXX: Implement casts for other pointer types as well
						    else if(v2.getType().getName().compareTo("*") ==  0) {
						      if (pt.getText().compareTo("char") == 0) {	  
						        returnVar = new Value(charPointerType);
					returnVar.assign(v2);
						      }
						    }  
						    else returnVar = v2;
					
				}
				break;
			}
			case EXPR_LIST:
			{
				AST __t57 = _t;
				// AST tmp50_AST_in = (AST)_t;
				match(_t,EXPR_LIST);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t57;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1;
					
				}
				break;
			}
			case FUNC_CALL:
			{
				AST __t58 = _t;
				// AST tmp51_AST_in = (AST)_t;
				match(_t,FUNC_CALL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t58;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1;
					
				}
				break;
			}
			case MEMBER:
			{
				AST __t59 = _t;
				// AST tmp52_AST_in = (AST)_t;
				match(_t,MEMBER);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				s1=identifier(_t);
				_t = _retTree;
				_t = __t59;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().member(v1, s1);
					
				}
				break;
			}
			case SIZEOF:
			{
				AST __t60 = _t;
				// AST tmp53_AST_in = (AST)_t;
				match(_t,SIZEOF);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t60;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = longType.createValue((long)(v1.getType().getSize())); 
					
				}
				break;
			}
			case INDEX:
			{
				AST __t61 = _t;
				// AST tmp54_AST_in = (AST)_t;
				match(_t,INDEX);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t61;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().index(v1, v2, exprSymTab.taskMemory());
					
				}
				break;
			}
			case SLICE:
			{
				AST __t62 = _t;
				// AST tmp55_AST_in = (AST)_t;
				match(_t,SLICE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				v3=expr(_t);
				_t = _retTree;
				_t = __t62;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().slice(v1, v2, v3, exprSymTab.taskMemory());
					
				}
				break;
			}
			case IDENT:
			{
				ident = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Value)exprSymTab.getValue(ident.getText()));
					
				}
				break;
			}
			case TAB_IDENT:
			{
				tident = (AST)_t;
				match(_t,TAB_IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Value)exprSymTab.getValue(tident.getText()));
					
				}
				break;
			}
			default:
				boolean synPredMatched10 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==MINUS))) {
					AST __t10 = _t;
					synPredMatched10 = true;
					inputState.guessing++;
					try {
						{
						AST __t9 = _t;
						// AST tmp56_AST_in = (AST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expr(_t);
						_t = _retTree;
						expr(_t);
						_t = _retTree;
						_t = __t9;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched10 = false;
					}
					_t = __t10;
inputState.guessing--;
				}
				if ( synPredMatched10 ) {
					AST __t11 = _t;
					// AST tmp57_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					v2=expr(_t);
					_t = _retTree;
					_t = __t11;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = v1.getType().getALU(v2.getType(), 
						exprSymTab.getWordSize())
						.subtract(v1, v2);  
						
					}
				}
				else if ((_t.getType()==MINUS)) {
					AST __t13 = _t;
					// AST tmp58_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					_t = __t13;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = intType.createValue(0);
						returnVar = returnVar.getType().getALU(v1.getType(), 
						exprSymTab.getWordSize())
						.subtract(returnVar, v1); 
						
					}
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return returnVar;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ADDRESS_OF",
		"ARG_LIST",
		"CAST",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"MEMORY",
		"MEMBER",
		"SIZEOF",
		"INDEX",
		"SLICE",
		"ARITHMETIC_PLUS",
		"ARITHMETIC_MINUS",
		"PREINCREMENT",
		"PREDECREMENT",
		"POSTINCREMENT",
		"POSTDECREMENT",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"DOTSTAR",
		"POINTERSTAR",
		"\"sizeof\"",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"LPAREN",
		"DOT",
		"IDENT_TAB",
		"IDENT",
		"POINTERTO",
		"LSQUARE",
		"RSQUARE",
		"SCOPE",
		"\"this\"",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"DOUBLE",
		"\"true\"",
		"\"false\"",
		"\"operator\"",
		"AT",
		"ETX",
		"LCURLY",
		"RCURLY",
		"ELLIPSIS",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM",
		"HEX_DIGIT",
		"EXPONENT",
		"FLOAT_SUFFIX",
		"TAB_IDENT"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 3494793181988388816L, 17592189419522L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	}
	
