package frysk.rsl;

public class Level
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private Level (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof Level))
      return false;
    return ((Level)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    Level rhs = (Level) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int NONE_ = 0;
  static public final Level NONE = new Level (0, "Level_NONE", "NONE", "NONE");
  static public final int WARNING_ = 1;
  static public final Level WARNING = new Level (1, "Level_WARNING", "WARNING", "WARNING");
  static public final int INFO_ = 2;
  static public final Level INFO = new Level (2, "Level_INFO", "INFO", "INFO");
  static public final int DEFAULT_ = INFO_;
  static public final Level DEFAULT = INFO;
  static public final int FINE_ = 3;
  static public final Level FINE = new Level (3, "Level_FINE", "FINE", "FINE");
  static public final int FINEST_ = 4;
  static public final Level FINEST = new Level (4, "Level_FINEST", "FINEST", "FINEST");
  static public final int MAX_ = 5;
  static public final Level MAX = new Level (5, "Level_MAX", "MAX", "MAX");

  /** Create a HashMap containing all the Level elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (NONE.enumName, NONE);
    map.put (WARNING.enumName, WARNING);
    map.put (INFO.enumName, INFO);
    map.put (FINE.enumName, FINE);
    map.put (FINEST.enumName, FINEST);
    map.put (MAX.enumName, MAX);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the Level object that matches the string.  */
  public static Level valueOf (String string)
  {
    return (Level)enumMap.get (string);
  }

  /** Return the Level object that matches the integer.  */
  public static Level valueOf (long i)
  {
    switch ((int)i) {
    case NONE_: return NONE;
    case WARNING_: return WARNING;
    case INFO_: return INFO;
    case FINE_: return FINE;
    case FINEST_: return FINEST;
    case MAX_: return MAX;
    default: return null;
    }
  }

  /** Return an array of all the Level elements.  */
  public static Level[] values ()
  {
    return (Level[]) enumMap.values ().toArray (new Level[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    Level c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    Level c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    Level c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    Level c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    Level c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
