package inua.elf;

public class AT
{
  static public final int NULL = 0;
  static public final int IGNORE = 1;
  static public final int EXECFD = 2;
  static public final int PHDR = 3;
  static public final int PHENT = 4;
  static public final int PHNUM = 5;
  static public final int PAGESZ = 6;
  static public final int BASE = 7;
  static public final int FLAGS = 8;
  static public final int ENTRY = 9;
  static public final int NOTELF = 10;
  static public final int UID = 11;
  static public final int EUID = 12;
  static public final int GID = 13;
  static public final int EGID = 14;
  static public final int CLKTCK = 17;
  static public final int PLATFORM = 15;
  static public final int HWCAP = 16;
  static public final int FPUCW = 18;
  static public final int DCACHEBSIZE = 19;
  static public final int ICACHEBSIZE = 20;
  static public final int UCACHEBSIZE = 21;
  static public final int IGNOREPPC = 22;
  static public final int SYSINFO = 32;
  static public final int SYSINFO_EHDR = 33;
  static public final int L1I_CACHESHAPE = 34;
  static public final int L1D_CACHESHAPE = 35;
  static public final int L2_CACHESHAPE = 36;
  static public final int L3_CACHESHAPE = 37;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NULL: return "AT_NULL";
    case IGNORE: return "AT_IGNORE";
    case EXECFD: return "AT_EXECFD";
    case PHDR: return "AT_PHDR";
    case PHENT: return "AT_PHENT";
    case PHNUM: return "AT_PHNUM";
    case PAGESZ: return "AT_PAGESZ";
    case BASE: return "AT_BASE";
    case FLAGS: return "AT_FLAGS";
    case ENTRY: return "AT_ENTRY";
    case NOTELF: return "AT_NOTELF";
    case UID: return "AT_UID";
    case EUID: return "AT_EUID";
    case GID: return "AT_GID";
    case EGID: return "AT_EGID";
    case CLKTCK: return "AT_CLKTCK";
    case PLATFORM: return "AT_PLATFORM";
    case HWCAP: return "AT_HWCAP";
    case FPUCW: return "AT_FPUCW";
    case DCACHEBSIZE: return "AT_DCACHEBSIZE";
    case ICACHEBSIZE: return "AT_ICACHEBSIZE";
    case UCACHEBSIZE: return "AT_UCACHEBSIZE";
    case IGNOREPPC: return "AT_IGNOREPPC";
    case SYSINFO: return "AT_SYSINFO";
    case SYSINFO_EHDR: return "AT_SYSINFO_EHDR";
    case L1I_CACHESHAPE: return "AT_L1I_CACHESHAPE";
    case L1D_CACHESHAPE: return "AT_L1D_CACHESHAPE";
    case L2_CACHESHAPE: return "AT_L2_CACHESHAPE";
    case L3_CACHESHAPE: return "AT_L3_CACHESHAPE";
    default: return "AT_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case IGNORE: return "IGNORE";
    case EXECFD: return "EXECFD";
    case PHDR: return "PHDR";
    case PHENT: return "PHENT";
    case PHNUM: return "PHNUM";
    case PAGESZ: return "PAGESZ";
    case BASE: return "BASE";
    case FLAGS: return "FLAGS";
    case ENTRY: return "ENTRY";
    case NOTELF: return "NOTELF";
    case UID: return "UID";
    case EUID: return "EUID";
    case GID: return "GID";
    case EGID: return "EGID";
    case CLKTCK: return "CLKTCK";
    case PLATFORM: return "PLATFORM";
    case HWCAP: return "HWCAP";
    case FPUCW: return "FPUCW";
    case DCACHEBSIZE: return "DCACHEBSIZE";
    case ICACHEBSIZE: return "ICACHEBSIZE";
    case UCACHEBSIZE: return "UCACHEBSIZE";
    case IGNOREPPC: return "IGNOREPPC";
    case SYSINFO: return "SYSINFO";
    case SYSINFO_EHDR: return "SYSINFO_EHDR";
    case L1I_CACHESHAPE: return "L1I_CACHESHAPE";
    case L1D_CACHESHAPE: return "L1D_CACHESHAPE";
    case L2_CACHESHAPE: return "L2_CACHESHAPE";
    case L3_CACHESHAPE: return "L3_CACHESHAPE";
    default: return "AT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NULL: return "End of vector";
    case IGNORE: return "Entry should be ignored";
    case EXECFD: return "File descriptor of program";
    case PHDR: return "Program headers for program";
    case PHENT: return "Size of program header entry";
    case PHNUM: return "Number of program headers";
    case PAGESZ: return "System page size";
    case BASE: return "Base address of interpreter";
    case FLAGS: return "Flags";
    case ENTRY: return "Entry point of program";
    case NOTELF: return "Program is not ELF";
    case UID: return "Real uid";
    case EUID: return "Effective uid";
    case GID: return "Real gid";
    case EGID: return "Effective gid";
    case CLKTCK: return "Frequency of times()";
    case PLATFORM: return "String identifying platform.";
    case HWCAP: return "Machine dependent hints about";
    case FPUCW: return "Used FPU control word.";
    case DCACHEBSIZE: return "Data cache block size.";
    case ICACHEBSIZE: return "Instruction cache block size.";
    case UCACHEBSIZE: return "Unified cache block size.";
    case IGNOREPPC: return "Entry should be ignored.";
    case SYSINFO: return "SYSINFO";
    case SYSINFO_EHDR: return "SYSINFO EHDR";
    case L1I_CACHESHAPE: return "L1I CACHESHAPE";
    case L1D_CACHESHAPE: return "L1D CACHESHAPE";
    case L2_CACHESHAPE: return "L2 CACHESHAPE";
    case L3_CACHESHAPE: return "L3 CACHESHAPE";
    default: return "AT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NULL: return "End of vector";
    case IGNORE: return "Entry should be ignored";
    case EXECFD: return "File descriptor of program";
    case PHDR: return "Program headers for program";
    case PHENT: return "Size of program header entry";
    case PHNUM: return "Number of program headers";
    case PAGESZ: return "System page size";
    case BASE: return "Base address of interpreter";
    case FLAGS: return "Flags";
    case ENTRY: return "Entry point of program";
    case NOTELF: return "Program is not ELF";
    case UID: return "Real uid";
    case EUID: return "Effective uid";
    case GID: return "Real gid";
    case EGID: return "Effective gid";
    case CLKTCK: return "Frequency of times()";
    case PLATFORM: return "String identifying platform.";
    case HWCAP: return "Machine dependent hints about";
    case FPUCW: return "Used FPU control word.";
    case DCACHEBSIZE: return "Data cache block size.";
    case ICACHEBSIZE: return "Instruction cache block size.";
    case UCACHEBSIZE: return "Unified cache block size.";
    case IGNOREPPC: return "Entry should be ignored.";
    case SYSINFO: return "SYSINFO";
    case SYSINFO_EHDR: return "SYSINFO EHDR";
    case L1I_CACHESHAPE: return "L1I CACHESHAPE";
    case L1D_CACHESHAPE: return "L1D CACHESHAPE";
    case L2_CACHESHAPE: return "L2 CACHESHAPE";
    case L3_CACHESHAPE: return "L3 CACHESHAPE";
    default: return def;
    }
  }
}
