package lib.dwfl;

public class DwAccess
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwAccess (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwAccess))
      return false;
    return ((DwAccess)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwAccess rhs = (DwAccess) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int PUBLIC_ = 1;
  static public final DwAccess PUBLIC = new DwAccess (1, "DwAccess_PUBLIC", "DW_ACCESS_public", "PUBLIC");
  static public final int PROTECTED_ = 2;
  static public final DwAccess PROTECTED = new DwAccess (2, "DwAccess_PROTECTED", "DW_ACCESS_protected", "PROTECTED");
  static public final int PRIVATE_ = 3;
  static public final DwAccess PRIVATE = new DwAccess (3, "DwAccess_PRIVATE", "DW_ACCESS_private", "PRIVATE");

  /** Create a HashMap containing all the DwAccess elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (PUBLIC.enumName, PUBLIC);
    map.put (PROTECTED.enumName, PROTECTED);
    map.put (PRIVATE.enumName, PRIVATE);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwAccess object that matches the string.  */
  public static DwAccess valueOf (String string)
  {
    return (DwAccess)enumMap.get (string);
  }

  /** Return the DwAccess object that matches the integer.  */
  public static DwAccess valueOf (long i)
  {
    switch ((int)i) {
    case PUBLIC_: return PUBLIC;
    case PROTECTED_: return PROTECTED;
    case PRIVATE_: return PRIVATE;
    default: return null;
    }
  }

  /** Return an array of all the DwAccess elements.  */
  public static DwAccess[] values ()
  {
    return (DwAccess[]) enumMap.values ().toArray (new DwAccess[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwAccess c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwAccess c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwAccess c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwAccess c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwAccess c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
