package lib.dwfl;

public class DwAt
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwAt (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwAt))
      return false;
    return ((DwAt)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwAt rhs = (DwAt) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int SIBLING_ = 0x01;
  static public final DwAt SIBLING = new DwAt (0x01, "DwAt_SIBLING", "DW_AT_sibling", "SIBLING");
  static public final int LOCATION_ = 0x02;
  static public final DwAt LOCATION = new DwAt (0x02, "DwAt_LOCATION", "DW_AT_location", "LOCATION");
  static public final int NAME_ = 0x03;
  static public final DwAt NAME = new DwAt (0x03, "DwAt_NAME", "DW_AT_name", "NAME");
  static public final int ORDERING_ = 0x09;
  static public final DwAt ORDERING = new DwAt (0x09, "DwAt_ORDERING", "DW_AT_ordering", "ORDERING");
  static public final int SUBSCR_DATA_ = 0x0a;
  static public final DwAt SUBSCR_DATA = new DwAt (0x0a, "DwAt_SUBSCR_DATA", "DW_AT_subscr_data", "SUBSCR_DATA");
  static public final int BYTE_SIZE_ = 0x0b;
  static public final DwAt BYTE_SIZE = new DwAt (0x0b, "DwAt_BYTE_SIZE", "DW_AT_byte_size", "BYTE_SIZE");
  static public final int BIT_OFFSET_ = 0x0c;
  static public final DwAt BIT_OFFSET = new DwAt (0x0c, "DwAt_BIT_OFFSET", "DW_AT_bit_offset", "BIT_OFFSET");
  static public final int BIT_SIZE_ = 0x0d;
  static public final DwAt BIT_SIZE = new DwAt (0x0d, "DwAt_BIT_SIZE", "DW_AT_bit_size", "BIT_SIZE");
  static public final int ELEMENT_LIST_ = 0x0f;
  static public final DwAt ELEMENT_LIST = new DwAt (0x0f, "DwAt_ELEMENT_LIST", "DW_AT_element_list", "ELEMENT_LIST");
  static public final int STMT_LIST_ = 0x10;
  static public final DwAt STMT_LIST = new DwAt (0x10, "DwAt_STMT_LIST", "DW_AT_stmt_list", "STMT_LIST");
  static public final int LOW_PC_ = 0x11;
  static public final DwAt LOW_PC = new DwAt (0x11, "DwAt_LOW_PC", "DW_AT_low_pc", "LOW_PC");
  static public final int HIGH_PC_ = 0x12;
  static public final DwAt HIGH_PC = new DwAt (0x12, "DwAt_HIGH_PC", "DW_AT_high_pc", "HIGH_PC");
  static public final int LANGUAGE_ = 0x13;
  static public final DwAt LANGUAGE = new DwAt (0x13, "DwAt_LANGUAGE", "DW_AT_language", "LANGUAGE");
  static public final int MEMBER_ = 0x14;
  static public final DwAt MEMBER = new DwAt (0x14, "DwAt_MEMBER", "DW_AT_member", "MEMBER");
  static public final int DISCR_ = 0x15;
  static public final DwAt DISCR = new DwAt (0x15, "DwAt_DISCR", "DW_AT_discr", "DISCR");
  static public final int DISCR_VALUE_ = 0x16;
  static public final DwAt DISCR_VALUE = new DwAt (0x16, "DwAt_DISCR_VALUE", "DW_AT_discr_value", "DISCR_VALUE");
  static public final int VISIBILITY_ = 0x17;
  static public final DwAt VISIBILITY = new DwAt (0x17, "DwAt_VISIBILITY", "DW_AT_visibility", "VISIBILITY");
  static public final int IMPORT_ = 0x18;
  static public final DwAt IMPORT = new DwAt (0x18, "DwAt_IMPORT", "DW_AT_import", "IMPORT");
  static public final int STRING_LENGTH_ = 0x19;
  static public final DwAt STRING_LENGTH = new DwAt (0x19, "DwAt_STRING_LENGTH", "DW_AT_string_length", "STRING_LENGTH");
  static public final int COMMON_REFERENCE_ = 0x1a;
  static public final DwAt COMMON_REFERENCE = new DwAt (0x1a, "DwAt_COMMON_REFERENCE", "DW_AT_common_reference", "COMMON_REFERENCE");
  static public final int COMP_DIR_ = 0x1b;
  static public final DwAt COMP_DIR = new DwAt (0x1b, "DwAt_COMP_DIR", "DW_AT_comp_dir", "COMP_DIR");
  static public final int CONST_VALUE_ = 0x1c;
  static public final DwAt CONST_VALUE = new DwAt (0x1c, "DwAt_CONST_VALUE", "DW_AT_const_value", "CONST_VALUE");
  static public final int CONTAINING_TYPE_ = 0x1d;
  static public final DwAt CONTAINING_TYPE = new DwAt (0x1d, "DwAt_CONTAINING_TYPE", "DW_AT_containing_type", "CONTAINING_TYPE");
  static public final int DEFAULT_VALUE_ = 0x1e;
  static public final DwAt DEFAULT_VALUE = new DwAt (0x1e, "DwAt_DEFAULT_VALUE", "DW_AT_default_value", "DEFAULT_VALUE");
  static public final int INLINE_ = 0x20;
  static public final DwAt INLINE = new DwAt (0x20, "DwAt_INLINE", "DW_AT_inline", "INLINE");
  static public final int IS_OPTIONAL_ = 0x21;
  static public final DwAt IS_OPTIONAL = new DwAt (0x21, "DwAt_IS_OPTIONAL", "DW_AT_is_optional", "IS_OPTIONAL");
  static public final int LOWER_BOUND_ = 0x22;
  static public final DwAt LOWER_BOUND = new DwAt (0x22, "DwAt_LOWER_BOUND", "DW_AT_lower_bound", "LOWER_BOUND");
  static public final int PRODUCER_ = 0x25;
  static public final DwAt PRODUCER = new DwAt (0x25, "DwAt_PRODUCER", "DW_AT_producer", "PRODUCER");
  static public final int PROTOTYPED_ = 0x27;
  static public final DwAt PROTOTYPED = new DwAt (0x27, "DwAt_PROTOTYPED", "DW_AT_prototyped", "PROTOTYPED");
  static public final int RETURN_ADDR_ = 0x2a;
  static public final DwAt RETURN_ADDR = new DwAt (0x2a, "DwAt_RETURN_ADDR", "DW_AT_return_addr", "RETURN_ADDR");
  static public final int START_SCOPE_ = 0x2c;
  static public final DwAt START_SCOPE = new DwAt (0x2c, "DwAt_START_SCOPE", "DW_AT_start_scope", "START_SCOPE");
  static public final int BIT_STRIDE_ = 0x2e;
  static public final DwAt BIT_STRIDE = new DwAt (0x2e, "DwAt_BIT_STRIDE", "DW_AT_bit_stride", "BIT_STRIDE");
  static public final int UPPER_BOUND_ = 0x2f;
  static public final DwAt UPPER_BOUND = new DwAt (0x2f, "DwAt_UPPER_BOUND", "DW_AT_upper_bound", "UPPER_BOUND");
  static public final int ABSTRACT_ORIGIN_ = 0x31;
  static public final DwAt ABSTRACT_ORIGIN = new DwAt (0x31, "DwAt_ABSTRACT_ORIGIN", "DW_AT_abstract_origin", "ABSTRACT_ORIGIN");
  static public final int ACCESSIBILITY_ = 0x32;
  static public final DwAt ACCESSIBILITY = new DwAt (0x32, "DwAt_ACCESSIBILITY", "DW_AT_accessibility", "ACCESSIBILITY");
  static public final int ADDRESS_CLASS_ = 0x33;
  static public final DwAt ADDRESS_CLASS = new DwAt (0x33, "DwAt_ADDRESS_CLASS", "DW_AT_address_class", "ADDRESS_CLASS");
  static public final int ARTIFICIAL_ = 0x34;
  static public final DwAt ARTIFICIAL = new DwAt (0x34, "DwAt_ARTIFICIAL", "DW_AT_artificial", "ARTIFICIAL");
  static public final int BASE_TYPES_ = 0x35;
  static public final DwAt BASE_TYPES = new DwAt (0x35, "DwAt_BASE_TYPES", "DW_AT_base_types", "BASE_TYPES");
  static public final int CALLING_CONVENTION_ = 0x36;
  static public final DwAt CALLING_CONVENTION = new DwAt (0x36, "DwAt_CALLING_CONVENTION", "DW_AT_calling_convention", "CALLING_CONVENTION");
  static public final int COUNT_ = 0x37;
  static public final DwAt COUNT = new DwAt (0x37, "DwAt_COUNT", "DW_AT_count", "COUNT");
  static public final int DATA_MEMBER_LOCATION_ = 0x38;
  static public final DwAt DATA_MEMBER_LOCATION = new DwAt (0x38, "DwAt_DATA_MEMBER_LOCATION", "DW_AT_data_member_location", "DATA_MEMBER_LOCATION");
  static public final int DECL_COLUMN_ = 0x39;
  static public final DwAt DECL_COLUMN = new DwAt (0x39, "DwAt_DECL_COLUMN", "DW_AT_decl_column", "DECL_COLUMN");
  static public final int DECL_FILE_ = 0x3a;
  static public final DwAt DECL_FILE = new DwAt (0x3a, "DwAt_DECL_FILE", "DW_AT_decl_file", "DECL_FILE");
  static public final int DECL_LINE_ = 0x3b;
  static public final DwAt DECL_LINE = new DwAt (0x3b, "DwAt_DECL_LINE", "DW_AT_decl_line", "DECL_LINE");
  static public final int DECLARATION_ = 0x3c;
  static public final DwAt DECLARATION = new DwAt (0x3c, "DwAt_DECLARATION", "DW_AT_declaration", "DECLARATION");
  static public final int DISCR_LIST_ = 0x3d;
  static public final DwAt DISCR_LIST = new DwAt (0x3d, "DwAt_DISCR_LIST", "DW_AT_discr_list", "DISCR_LIST");
  static public final int ENCODING_ = 0x3e;
  static public final DwAt ENCODING = new DwAt (0x3e, "DwAt_ENCODING", "DW_AT_encoding", "ENCODING");
  static public final int EXTERNAL_ = 0x3f;
  static public final DwAt EXTERNAL = new DwAt (0x3f, "DwAt_EXTERNAL", "DW_AT_external", "EXTERNAL");
  static public final int FRAME_BASE_ = 0x40;
  static public final DwAt FRAME_BASE = new DwAt (0x40, "DwAt_FRAME_BASE", "DW_AT_frame_base", "FRAME_BASE");
  static public final int FRIEND_ = 0x41;
  static public final DwAt FRIEND = new DwAt (0x41, "DwAt_FRIEND", "DW_AT_friend", "FRIEND");
  static public final int IDENTIFIER_CASE_ = 0x42;
  static public final DwAt IDENTIFIER_CASE = new DwAt (0x42, "DwAt_IDENTIFIER_CASE", "DW_AT_identifier_case", "IDENTIFIER_CASE");
  static public final int MACRO_INFO_ = 0x43;
  static public final DwAt MACRO_INFO = new DwAt (0x43, "DwAt_MACRO_INFO", "DW_AT_macro_info", "MACRO_INFO");
  static public final int NAMELIST_ITEM_ = 0x44;
  static public final DwAt NAMELIST_ITEM = new DwAt (0x44, "DwAt_NAMELIST_ITEM", "DW_AT_namelist_item", "NAMELIST_ITEM");
  static public final int PRIORITY_ = 0x45;
  static public final DwAt PRIORITY = new DwAt (0x45, "DwAt_PRIORITY", "DW_AT_priority", "PRIORITY");
  static public final int SEGMENT_ = 0x46;
  static public final DwAt SEGMENT = new DwAt (0x46, "DwAt_SEGMENT", "DW_AT_segment", "SEGMENT");
  static public final int SPECIFICATION_ = 0x47;
  static public final DwAt SPECIFICATION = new DwAt (0x47, "DwAt_SPECIFICATION", "DW_AT_specification", "SPECIFICATION");
  static public final int STATIC_LINK_ = 0x48;
  static public final DwAt STATIC_LINK = new DwAt (0x48, "DwAt_STATIC_LINK", "DW_AT_static_link", "STATIC_LINK");
  static public final int TYPE_ = 0x49;
  static public final DwAt TYPE = new DwAt (0x49, "DwAt_TYPE", "DW_AT_type", "TYPE");
  static public final int USE_LOCATION_ = 0x4a;
  static public final DwAt USE_LOCATION = new DwAt (0x4a, "DwAt_USE_LOCATION", "DW_AT_use_location", "USE_LOCATION");
  static public final int VARIABLE_PARAMETER_ = 0x4b;
  static public final DwAt VARIABLE_PARAMETER = new DwAt (0x4b, "DwAt_VARIABLE_PARAMETER", "DW_AT_variable_parameter", "VARIABLE_PARAMETER");
  static public final int VIRTUALITY_ = 0x4c;
  static public final DwAt VIRTUALITY = new DwAt (0x4c, "DwAt_VIRTUALITY", "DW_AT_virtuality", "VIRTUALITY");
  static public final int VTABLE_ELEM_LOCATION_ = 0x4d;
  static public final DwAt VTABLE_ELEM_LOCATION = new DwAt (0x4d, "DwAt_VTABLE_ELEM_LOCATION", "DW_AT_vtable_elem_location", "VTABLE_ELEM_LOCATION");
  static public final int ALLOCATED_ = 0x4e;
  static public final DwAt ALLOCATED = new DwAt (0x4e, "DwAt_ALLOCATED", "DW_AT_allocated", "ALLOCATED");
  static public final int ASSOCIATED_ = 0x4f;
  static public final DwAt ASSOCIATED = new DwAt (0x4f, "DwAt_ASSOCIATED", "DW_AT_associated", "ASSOCIATED");
  static public final int DATA_LOCATION_ = 0x50;
  static public final DwAt DATA_LOCATION = new DwAt (0x50, "DwAt_DATA_LOCATION", "DW_AT_data_location", "DATA_LOCATION");
  static public final int BYTE_STRIDE_ = 0x51;
  static public final DwAt BYTE_STRIDE = new DwAt (0x51, "DwAt_BYTE_STRIDE", "DW_AT_byte_stride", "BYTE_STRIDE");
  static public final int ENTRY_PC_ = 0x52;
  static public final DwAt ENTRY_PC = new DwAt (0x52, "DwAt_ENTRY_PC", "DW_AT_entry_pc", "ENTRY_PC");
  static public final int USE_UTF8_ = 0x53;
  static public final DwAt USE_UTF8 = new DwAt (0x53, "DwAt_USE_UTF8", "DW_AT_use_UTF8", "USE_UTF8");
  static public final int EXTENSION_ = 0x54;
  static public final DwAt EXTENSION = new DwAt (0x54, "DwAt_EXTENSION", "DW_AT_extension", "EXTENSION");
  static public final int RANGES_ = 0x55;
  static public final DwAt RANGES = new DwAt (0x55, "DwAt_RANGES", "DW_AT_ranges", "RANGES");
  static public final int TRAMPOLINE_ = 0x56;
  static public final DwAt TRAMPOLINE = new DwAt (0x56, "DwAt_TRAMPOLINE", "DW_AT_trampoline", "TRAMPOLINE");
  static public final int CALL_COLUMN_ = 0x57;
  static public final DwAt CALL_COLUMN = new DwAt (0x57, "DwAt_CALL_COLUMN", "DW_AT_call_column", "CALL_COLUMN");
  static public final int CALL_FILE_ = 0x58;
  static public final DwAt CALL_FILE = new DwAt (0x58, "DwAt_CALL_FILE", "DW_AT_call_file", "CALL_FILE");
  static public final int CALL_LINE_ = 0x59;
  static public final DwAt CALL_LINE = new DwAt (0x59, "DwAt_CALL_LINE", "DW_AT_call_line", "CALL_LINE");
  static public final int DESCRIPTION_ = 0x5a;
  static public final DwAt DESCRIPTION = new DwAt (0x5a, "DwAt_DESCRIPTION", "DW_AT_description", "DESCRIPTION");
  static public final int BINARY_SCALE_ = 0x5b;
  static public final DwAt BINARY_SCALE = new DwAt (0x5b, "DwAt_BINARY_SCALE", "DW_AT_binary_scale", "BINARY_SCALE");
  static public final int DECIMAL_SCALE_ = 0x5c;
  static public final DwAt DECIMAL_SCALE = new DwAt (0x5c, "DwAt_DECIMAL_SCALE", "DW_AT_decimal_scale", "DECIMAL_SCALE");
  static public final int SMALL_ = 0x5d;
  static public final DwAt SMALL = new DwAt (0x5d, "DwAt_SMALL", "DW_AT_small", "SMALL");
  static public final int DECIMAL_SIGN_ = 0x5e;
  static public final DwAt DECIMAL_SIGN = new DwAt (0x5e, "DwAt_DECIMAL_SIGN", "DW_AT_decimal_sign", "DECIMAL_SIGN");
  static public final int DIGIT_COUNT_ = 0x5f;
  static public final DwAt DIGIT_COUNT = new DwAt (0x5f, "DwAt_DIGIT_COUNT", "DW_AT_digit_count", "DIGIT_COUNT");
  static public final int PICTURE_STRING_ = 0x60;
  static public final DwAt PICTURE_STRING = new DwAt (0x60, "DwAt_PICTURE_STRING", "DW_AT_picture_string", "PICTURE_STRING");
  static public final int MUTABLE_ = 0x61;
  static public final DwAt MUTABLE = new DwAt (0x61, "DwAt_MUTABLE", "DW_AT_mutable", "MUTABLE");
  static public final int THREADS_SCALED_ = 0x62;
  static public final DwAt THREADS_SCALED = new DwAt (0x62, "DwAt_THREADS_SCALED", "DW_AT_threads_scaled", "THREADS_SCALED");
  static public final int EXPLICIT_ = 0x63;
  static public final DwAt EXPLICIT = new DwAt (0x63, "DwAt_EXPLICIT", "DW_AT_explicit", "EXPLICIT");
  static public final int OBJECT_POINTER_ = 0x64;
  static public final DwAt OBJECT_POINTER = new DwAt (0x64, "DwAt_OBJECT_POINTER", "DW_AT_object_pointer", "OBJECT_POINTER");
  static public final int ENDIANITY_ = 0x65;
  static public final DwAt ENDIANITY = new DwAt (0x65, "DwAt_ENDIANITY", "DW_AT_endianity", "ENDIANITY");
  static public final int ELEMENTAL_ = 0x66;
  static public final DwAt ELEMENTAL = new DwAt (0x66, "DwAt_ELEMENTAL", "DW_AT_elemental", "ELEMENTAL");
  static public final int PURE_ = 0x67;
  static public final DwAt PURE = new DwAt (0x67, "DwAt_PURE", "DW_AT_pure", "PURE");
  static public final int RECURSIVE_ = 0x68;
  static public final DwAt RECURSIVE = new DwAt (0x68, "DwAt_RECURSIVE", "DW_AT_recursive", "RECURSIVE");
  static public final int LO_USER_ = 0x2000;
  static public final DwAt LO_USER = new DwAt (0x2000, "DwAt_LO_USER", "DW_AT_lo_user", "LO_USER");
  static public final int MIPS_FDE_ = 0x2001;
  static public final DwAt MIPS_FDE = new DwAt (0x2001, "DwAt_MIPS_FDE", "DW_AT_MIPS_fde", "MIPS_FDE");
  static public final int MIPS_LOOP_BEGIN_ = 0x2002;
  static public final DwAt MIPS_LOOP_BEGIN = new DwAt (0x2002, "DwAt_MIPS_LOOP_BEGIN", "DW_AT_MIPS_loop_begin", "MIPS_LOOP_BEGIN");
  static public final int MIPS_TAIL_LOOP_BEGIN_ = 0x2003;
  static public final DwAt MIPS_TAIL_LOOP_BEGIN = new DwAt (0x2003, "DwAt_MIPS_TAIL_LOOP_BEGIN", "DW_AT_MIPS_tail_loop_begin", "MIPS_TAIL_LOOP_BEGIN");
  static public final int MIPS_EPILOG_BEGIN_ = 0x2004;
  static public final DwAt MIPS_EPILOG_BEGIN = new DwAt (0x2004, "DwAt_MIPS_EPILOG_BEGIN", "DW_AT_MIPS_epilog_begin", "MIPS_EPILOG_BEGIN");
  static public final int MIPS_LOOP_UNROLL_FACTOR_ = 0x2005;
  static public final DwAt MIPS_LOOP_UNROLL_FACTOR = new DwAt (0x2005, "DwAt_MIPS_LOOP_UNROLL_FACTOR", "DW_AT_MIPS_loop_unroll_factor", "MIPS_LOOP_UNROLL_FACTOR");
  static public final int MIPS_SOFTWARE_PIPELINE_DEPTH_ = 0x2006;
  static public final DwAt MIPS_SOFTWARE_PIPELINE_DEPTH = new DwAt (0x2006, "DwAt_MIPS_SOFTWARE_PIPELINE_DEPTH", "DW_AT_MIPS_software_pipeline_depth", "MIPS_SOFTWARE_PIPELINE_DEPTH");
  static public final int MIPS_LINKAGE_NAME_ = 0x2007;
  static public final DwAt MIPS_LINKAGE_NAME = new DwAt (0x2007, "DwAt_MIPS_LINKAGE_NAME", "DW_AT_MIPS_linkage_name", "MIPS_LINKAGE_NAME");
  static public final int MIPS_STRIDE_ = 0x2008;
  static public final DwAt MIPS_STRIDE = new DwAt (0x2008, "DwAt_MIPS_STRIDE", "DW_AT_MIPS_stride", "MIPS_STRIDE");
  static public final int MIPS_ABSTRACT_NAME_ = 0x2009;
  static public final DwAt MIPS_ABSTRACT_NAME = new DwAt (0x2009, "DwAt_MIPS_ABSTRACT_NAME", "DW_AT_MIPS_abstract_name", "MIPS_ABSTRACT_NAME");
  static public final int MIPS_CLONE_ORIGIN_ = 0x200a;
  static public final DwAt MIPS_CLONE_ORIGIN = new DwAt (0x200a, "DwAt_MIPS_CLONE_ORIGIN", "DW_AT_MIPS_clone_origin", "MIPS_CLONE_ORIGIN");
  static public final int MIPS_HAS_INLINES_ = 0x200b;
  static public final DwAt MIPS_HAS_INLINES = new DwAt (0x200b, "DwAt_MIPS_HAS_INLINES", "DW_AT_MIPS_has_inlines", "MIPS_HAS_INLINES");
  static public final int MIPS_STRIDE_BYTE_ = 0x200c;
  static public final DwAt MIPS_STRIDE_BYTE = new DwAt (0x200c, "DwAt_MIPS_STRIDE_BYTE", "DW_AT_MIPS_stride_byte", "MIPS_STRIDE_BYTE");
  static public final int MIPS_STRIDE_ELEM_ = 0x200d;
  static public final DwAt MIPS_STRIDE_ELEM = new DwAt (0x200d, "DwAt_MIPS_STRIDE_ELEM", "DW_AT_MIPS_stride_elem", "MIPS_STRIDE_ELEM");
  static public final int MIPS_PTR_DOPETYPE_ = 0x200e;
  static public final DwAt MIPS_PTR_DOPETYPE = new DwAt (0x200e, "DwAt_MIPS_PTR_DOPETYPE", "DW_AT_MIPS_ptr_dopetype", "MIPS_PTR_DOPETYPE");
  static public final int MIPS_ALLOCATABLE_DOPETYPE_ = 0x200f;
  static public final DwAt MIPS_ALLOCATABLE_DOPETYPE = new DwAt (0x200f, "DwAt_MIPS_ALLOCATABLE_DOPETYPE", "DW_AT_MIPS_allocatable_dopetype", "MIPS_ALLOCATABLE_DOPETYPE");
  static public final int MIPS_ASSUMED_SHAPE_DOPETYPE_ = 0x2010;
  static public final DwAt MIPS_ASSUMED_SHAPE_DOPETYPE = new DwAt (0x2010, "DwAt_MIPS_ASSUMED_SHAPE_DOPETYPE", "DW_AT_MIPS_assumed_shape_dopetype", "MIPS_ASSUMED_SHAPE_DOPETYPE");
  static public final int MIPS_ASSUMED_SIZE_ = 0x2011;
  static public final DwAt MIPS_ASSUMED_SIZE = new DwAt (0x2011, "DwAt_MIPS_ASSUMED_SIZE", "DW_AT_MIPS_assumed_size", "MIPS_ASSUMED_SIZE");
  static public final int SF_NAMES_ = 0x2101;
  static public final DwAt SF_NAMES = new DwAt (0x2101, "DwAt_SF_NAMES", "DW_AT_sf_names", "SF_NAMES");
  static public final int SRC_INFO_ = 0x2102;
  static public final DwAt SRC_INFO = new DwAt (0x2102, "DwAt_SRC_INFO", "DW_AT_src_info", "SRC_INFO");
  static public final int MAC_INFO_ = 0x2103;
  static public final DwAt MAC_INFO = new DwAt (0x2103, "DwAt_MAC_INFO", "DW_AT_mac_info", "MAC_INFO");
  static public final int SRC_COORDS_ = 0x2104;
  static public final DwAt SRC_COORDS = new DwAt (0x2104, "DwAt_SRC_COORDS", "DW_AT_src_coords", "SRC_COORDS");
  static public final int BODY_BEGIN_ = 0x2105;
  static public final DwAt BODY_BEGIN = new DwAt (0x2105, "DwAt_BODY_BEGIN", "DW_AT_body_begin", "BODY_BEGIN");
  static public final int BODY_END_ = 0x2106;
  static public final DwAt BODY_END = new DwAt (0x2106, "DwAt_BODY_END", "DW_AT_body_end", "BODY_END");
  static public final int HI_USER_ = 0x3fff;
  static public final DwAt HI_USER = new DwAt (0x3fff, "DwAt_HI_USER", "DW_AT_hi_user", "HI_USER");

  /** Create a HashMap containing all the DwAt elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (SIBLING.enumName, SIBLING);
    map.put (LOCATION.enumName, LOCATION);
    map.put (NAME.enumName, NAME);
    map.put (ORDERING.enumName, ORDERING);
    map.put (SUBSCR_DATA.enumName, SUBSCR_DATA);
    map.put (BYTE_SIZE.enumName, BYTE_SIZE);
    map.put (BIT_OFFSET.enumName, BIT_OFFSET);
    map.put (BIT_SIZE.enumName, BIT_SIZE);
    map.put (ELEMENT_LIST.enumName, ELEMENT_LIST);
    map.put (STMT_LIST.enumName, STMT_LIST);
    map.put (LOW_PC.enumName, LOW_PC);
    map.put (HIGH_PC.enumName, HIGH_PC);
    map.put (LANGUAGE.enumName, LANGUAGE);
    map.put (MEMBER.enumName, MEMBER);
    map.put (DISCR.enumName, DISCR);
    map.put (DISCR_VALUE.enumName, DISCR_VALUE);
    map.put (VISIBILITY.enumName, VISIBILITY);
    map.put (IMPORT.enumName, IMPORT);
    map.put (STRING_LENGTH.enumName, STRING_LENGTH);
    map.put (COMMON_REFERENCE.enumName, COMMON_REFERENCE);
    map.put (COMP_DIR.enumName, COMP_DIR);
    map.put (CONST_VALUE.enumName, CONST_VALUE);
    map.put (CONTAINING_TYPE.enumName, CONTAINING_TYPE);
    map.put (DEFAULT_VALUE.enumName, DEFAULT_VALUE);
    map.put (INLINE.enumName, INLINE);
    map.put (IS_OPTIONAL.enumName, IS_OPTIONAL);
    map.put (LOWER_BOUND.enumName, LOWER_BOUND);
    map.put (PRODUCER.enumName, PRODUCER);
    map.put (PROTOTYPED.enumName, PROTOTYPED);
    map.put (RETURN_ADDR.enumName, RETURN_ADDR);
    map.put (START_SCOPE.enumName, START_SCOPE);
    map.put (BIT_STRIDE.enumName, BIT_STRIDE);
    map.put (UPPER_BOUND.enumName, UPPER_BOUND);
    map.put (ABSTRACT_ORIGIN.enumName, ABSTRACT_ORIGIN);
    map.put (ACCESSIBILITY.enumName, ACCESSIBILITY);
    map.put (ADDRESS_CLASS.enumName, ADDRESS_CLASS);
    map.put (ARTIFICIAL.enumName, ARTIFICIAL);
    map.put (BASE_TYPES.enumName, BASE_TYPES);
    map.put (CALLING_CONVENTION.enumName, CALLING_CONVENTION);
    map.put (COUNT.enumName, COUNT);
    map.put (DATA_MEMBER_LOCATION.enumName, DATA_MEMBER_LOCATION);
    map.put (DECL_COLUMN.enumName, DECL_COLUMN);
    map.put (DECL_FILE.enumName, DECL_FILE);
    map.put (DECL_LINE.enumName, DECL_LINE);
    map.put (DECLARATION.enumName, DECLARATION);
    map.put (DISCR_LIST.enumName, DISCR_LIST);
    map.put (ENCODING.enumName, ENCODING);
    map.put (EXTERNAL.enumName, EXTERNAL);
    map.put (FRAME_BASE.enumName, FRAME_BASE);
    map.put (FRIEND.enumName, FRIEND);
    map.put (IDENTIFIER_CASE.enumName, IDENTIFIER_CASE);
    map.put (MACRO_INFO.enumName, MACRO_INFO);
    map.put (NAMELIST_ITEM.enumName, NAMELIST_ITEM);
    map.put (PRIORITY.enumName, PRIORITY);
    map.put (SEGMENT.enumName, SEGMENT);
    map.put (SPECIFICATION.enumName, SPECIFICATION);
    map.put (STATIC_LINK.enumName, STATIC_LINK);
    map.put (TYPE.enumName, TYPE);
    map.put (USE_LOCATION.enumName, USE_LOCATION);
    map.put (VARIABLE_PARAMETER.enumName, VARIABLE_PARAMETER);
    map.put (VIRTUALITY.enumName, VIRTUALITY);
    map.put (VTABLE_ELEM_LOCATION.enumName, VTABLE_ELEM_LOCATION);
    map.put (ALLOCATED.enumName, ALLOCATED);
    map.put (ASSOCIATED.enumName, ASSOCIATED);
    map.put (DATA_LOCATION.enumName, DATA_LOCATION);
    map.put (BYTE_STRIDE.enumName, BYTE_STRIDE);
    map.put (ENTRY_PC.enumName, ENTRY_PC);
    map.put (USE_UTF8.enumName, USE_UTF8);
    map.put (EXTENSION.enumName, EXTENSION);
    map.put (RANGES.enumName, RANGES);
    map.put (TRAMPOLINE.enumName, TRAMPOLINE);
    map.put (CALL_COLUMN.enumName, CALL_COLUMN);
    map.put (CALL_FILE.enumName, CALL_FILE);
    map.put (CALL_LINE.enumName, CALL_LINE);
    map.put (DESCRIPTION.enumName, DESCRIPTION);
    map.put (BINARY_SCALE.enumName, BINARY_SCALE);
    map.put (DECIMAL_SCALE.enumName, DECIMAL_SCALE);
    map.put (SMALL.enumName, SMALL);
    map.put (DECIMAL_SIGN.enumName, DECIMAL_SIGN);
    map.put (DIGIT_COUNT.enumName, DIGIT_COUNT);
    map.put (PICTURE_STRING.enumName, PICTURE_STRING);
    map.put (MUTABLE.enumName, MUTABLE);
    map.put (THREADS_SCALED.enumName, THREADS_SCALED);
    map.put (EXPLICIT.enumName, EXPLICIT);
    map.put (OBJECT_POINTER.enumName, OBJECT_POINTER);
    map.put (ENDIANITY.enumName, ENDIANITY);
    map.put (ELEMENTAL.enumName, ELEMENTAL);
    map.put (PURE.enumName, PURE);
    map.put (RECURSIVE.enumName, RECURSIVE);
    map.put (LO_USER.enumName, LO_USER);
    map.put (MIPS_FDE.enumName, MIPS_FDE);
    map.put (MIPS_LOOP_BEGIN.enumName, MIPS_LOOP_BEGIN);
    map.put (MIPS_TAIL_LOOP_BEGIN.enumName, MIPS_TAIL_LOOP_BEGIN);
    map.put (MIPS_EPILOG_BEGIN.enumName, MIPS_EPILOG_BEGIN);
    map.put (MIPS_LOOP_UNROLL_FACTOR.enumName, MIPS_LOOP_UNROLL_FACTOR);
    map.put (MIPS_SOFTWARE_PIPELINE_DEPTH.enumName, MIPS_SOFTWARE_PIPELINE_DEPTH);
    map.put (MIPS_LINKAGE_NAME.enumName, MIPS_LINKAGE_NAME);
    map.put (MIPS_STRIDE.enumName, MIPS_STRIDE);
    map.put (MIPS_ABSTRACT_NAME.enumName, MIPS_ABSTRACT_NAME);
    map.put (MIPS_CLONE_ORIGIN.enumName, MIPS_CLONE_ORIGIN);
    map.put (MIPS_HAS_INLINES.enumName, MIPS_HAS_INLINES);
    map.put (MIPS_STRIDE_BYTE.enumName, MIPS_STRIDE_BYTE);
    map.put (MIPS_STRIDE_ELEM.enumName, MIPS_STRIDE_ELEM);
    map.put (MIPS_PTR_DOPETYPE.enumName, MIPS_PTR_DOPETYPE);
    map.put (MIPS_ALLOCATABLE_DOPETYPE.enumName, MIPS_ALLOCATABLE_DOPETYPE);
    map.put (MIPS_ASSUMED_SHAPE_DOPETYPE.enumName, MIPS_ASSUMED_SHAPE_DOPETYPE);
    map.put (MIPS_ASSUMED_SIZE.enumName, MIPS_ASSUMED_SIZE);
    map.put (SF_NAMES.enumName, SF_NAMES);
    map.put (SRC_INFO.enumName, SRC_INFO);
    map.put (MAC_INFO.enumName, MAC_INFO);
    map.put (SRC_COORDS.enumName, SRC_COORDS);
    map.put (BODY_BEGIN.enumName, BODY_BEGIN);
    map.put (BODY_END.enumName, BODY_END);
    map.put (HI_USER.enumName, HI_USER);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwAt object that matches the string.  */
  public static DwAt valueOf (String string)
  {
    return (DwAt)enumMap.get (string);
  }

  /** Return the DwAt object that matches the integer.  */
  public static DwAt valueOf (long i)
  {
    switch ((int)i) {
    case SIBLING_: return SIBLING;
    case LOCATION_: return LOCATION;
    case NAME_: return NAME;
    case ORDERING_: return ORDERING;
    case SUBSCR_DATA_: return SUBSCR_DATA;
    case BYTE_SIZE_: return BYTE_SIZE;
    case BIT_OFFSET_: return BIT_OFFSET;
    case BIT_SIZE_: return BIT_SIZE;
    case ELEMENT_LIST_: return ELEMENT_LIST;
    case STMT_LIST_: return STMT_LIST;
    case LOW_PC_: return LOW_PC;
    case HIGH_PC_: return HIGH_PC;
    case LANGUAGE_: return LANGUAGE;
    case MEMBER_: return MEMBER;
    case DISCR_: return DISCR;
    case DISCR_VALUE_: return DISCR_VALUE;
    case VISIBILITY_: return VISIBILITY;
    case IMPORT_: return IMPORT;
    case STRING_LENGTH_: return STRING_LENGTH;
    case COMMON_REFERENCE_: return COMMON_REFERENCE;
    case COMP_DIR_: return COMP_DIR;
    case CONST_VALUE_: return CONST_VALUE;
    case CONTAINING_TYPE_: return CONTAINING_TYPE;
    case DEFAULT_VALUE_: return DEFAULT_VALUE;
    case INLINE_: return INLINE;
    case IS_OPTIONAL_: return IS_OPTIONAL;
    case LOWER_BOUND_: return LOWER_BOUND;
    case PRODUCER_: return PRODUCER;
    case PROTOTYPED_: return PROTOTYPED;
    case RETURN_ADDR_: return RETURN_ADDR;
    case START_SCOPE_: return START_SCOPE;
    case BIT_STRIDE_: return BIT_STRIDE;
    case UPPER_BOUND_: return UPPER_BOUND;
    case ABSTRACT_ORIGIN_: return ABSTRACT_ORIGIN;
    case ACCESSIBILITY_: return ACCESSIBILITY;
    case ADDRESS_CLASS_: return ADDRESS_CLASS;
    case ARTIFICIAL_: return ARTIFICIAL;
    case BASE_TYPES_: return BASE_TYPES;
    case CALLING_CONVENTION_: return CALLING_CONVENTION;
    case COUNT_: return COUNT;
    case DATA_MEMBER_LOCATION_: return DATA_MEMBER_LOCATION;
    case DECL_COLUMN_: return DECL_COLUMN;
    case DECL_FILE_: return DECL_FILE;
    case DECL_LINE_: return DECL_LINE;
    case DECLARATION_: return DECLARATION;
    case DISCR_LIST_: return DISCR_LIST;
    case ENCODING_: return ENCODING;
    case EXTERNAL_: return EXTERNAL;
    case FRAME_BASE_: return FRAME_BASE;
    case FRIEND_: return FRIEND;
    case IDENTIFIER_CASE_: return IDENTIFIER_CASE;
    case MACRO_INFO_: return MACRO_INFO;
    case NAMELIST_ITEM_: return NAMELIST_ITEM;
    case PRIORITY_: return PRIORITY;
    case SEGMENT_: return SEGMENT;
    case SPECIFICATION_: return SPECIFICATION;
    case STATIC_LINK_: return STATIC_LINK;
    case TYPE_: return TYPE;
    case USE_LOCATION_: return USE_LOCATION;
    case VARIABLE_PARAMETER_: return VARIABLE_PARAMETER;
    case VIRTUALITY_: return VIRTUALITY;
    case VTABLE_ELEM_LOCATION_: return VTABLE_ELEM_LOCATION;
    case ALLOCATED_: return ALLOCATED;
    case ASSOCIATED_: return ASSOCIATED;
    case DATA_LOCATION_: return DATA_LOCATION;
    case BYTE_STRIDE_: return BYTE_STRIDE;
    case ENTRY_PC_: return ENTRY_PC;
    case USE_UTF8_: return USE_UTF8;
    case EXTENSION_: return EXTENSION;
    case RANGES_: return RANGES;
    case TRAMPOLINE_: return TRAMPOLINE;
    case CALL_COLUMN_: return CALL_COLUMN;
    case CALL_FILE_: return CALL_FILE;
    case CALL_LINE_: return CALL_LINE;
    case DESCRIPTION_: return DESCRIPTION;
    case BINARY_SCALE_: return BINARY_SCALE;
    case DECIMAL_SCALE_: return DECIMAL_SCALE;
    case SMALL_: return SMALL;
    case DECIMAL_SIGN_: return DECIMAL_SIGN;
    case DIGIT_COUNT_: return DIGIT_COUNT;
    case PICTURE_STRING_: return PICTURE_STRING;
    case MUTABLE_: return MUTABLE;
    case THREADS_SCALED_: return THREADS_SCALED;
    case EXPLICIT_: return EXPLICIT;
    case OBJECT_POINTER_: return OBJECT_POINTER;
    case ENDIANITY_: return ENDIANITY;
    case ELEMENTAL_: return ELEMENTAL;
    case PURE_: return PURE;
    case RECURSIVE_: return RECURSIVE;
    case LO_USER_: return LO_USER;
    case MIPS_FDE_: return MIPS_FDE;
    case MIPS_LOOP_BEGIN_: return MIPS_LOOP_BEGIN;
    case MIPS_TAIL_LOOP_BEGIN_: return MIPS_TAIL_LOOP_BEGIN;
    case MIPS_EPILOG_BEGIN_: return MIPS_EPILOG_BEGIN;
    case MIPS_LOOP_UNROLL_FACTOR_: return MIPS_LOOP_UNROLL_FACTOR;
    case MIPS_SOFTWARE_PIPELINE_DEPTH_: return MIPS_SOFTWARE_PIPELINE_DEPTH;
    case MIPS_LINKAGE_NAME_: return MIPS_LINKAGE_NAME;
    case MIPS_STRIDE_: return MIPS_STRIDE;
    case MIPS_ABSTRACT_NAME_: return MIPS_ABSTRACT_NAME;
    case MIPS_CLONE_ORIGIN_: return MIPS_CLONE_ORIGIN;
    case MIPS_HAS_INLINES_: return MIPS_HAS_INLINES;
    case MIPS_STRIDE_BYTE_: return MIPS_STRIDE_BYTE;
    case MIPS_STRIDE_ELEM_: return MIPS_STRIDE_ELEM;
    case MIPS_PTR_DOPETYPE_: return MIPS_PTR_DOPETYPE;
    case MIPS_ALLOCATABLE_DOPETYPE_: return MIPS_ALLOCATABLE_DOPETYPE;
    case MIPS_ASSUMED_SHAPE_DOPETYPE_: return MIPS_ASSUMED_SHAPE_DOPETYPE;
    case MIPS_ASSUMED_SIZE_: return MIPS_ASSUMED_SIZE;
    case SF_NAMES_: return SF_NAMES;
    case SRC_INFO_: return SRC_INFO;
    case MAC_INFO_: return MAC_INFO;
    case SRC_COORDS_: return SRC_COORDS;
    case BODY_BEGIN_: return BODY_BEGIN;
    case BODY_END_: return BODY_END;
    case HI_USER_: return HI_USER;
    default: return null;
    }
  }

  /** Return an array of all the DwAt elements.  */
  public static DwAt[] values ()
  {
    return (DwAt[]) enumMap.values ().toArray (new DwAt[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwAt c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwAt c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwAt c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwAt c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwAt c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
