package lib.dwfl;

public class DwAte
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwAte (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwAte))
      return false;
    return ((DwAte)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwAte rhs = (DwAte) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int VOID_ = 0x0;
  static public final DwAte VOID = new DwAte (0x0, "DwAte_VOID", "DW_ATE_void", "VOID");
  static public final int ADDRESS_ = 0x1;
  static public final DwAte ADDRESS = new DwAte (0x1, "DwAte_ADDRESS", "DW_ATE_address", "ADDRESS");
  static public final int BOOLEAN_ = 0x2;
  static public final DwAte BOOLEAN = new DwAte (0x2, "DwAte_BOOLEAN", "DW_ATE_boolean", "BOOLEAN");
  static public final int COMPLEX_FLOAT_ = 0x3;
  static public final DwAte COMPLEX_FLOAT = new DwAte (0x3, "DwAte_COMPLEX_FLOAT", "DW_ATE_complex_float", "COMPLEX_FLOAT");
  static public final int FLOAT_ = 0x4;
  static public final DwAte FLOAT = new DwAte (0x4, "DwAte_FLOAT", "DW_ATE_float", "FLOAT");
  static public final int SIGNED_ = 0x5;
  static public final DwAte SIGNED = new DwAte (0x5, "DwAte_SIGNED", "DW_ATE_signed", "SIGNED");
  static public final int SIGNED_CHAR_ = 0x6;
  static public final DwAte SIGNED_CHAR = new DwAte (0x6, "DwAte_SIGNED_CHAR", "DW_ATE_signed_char", "SIGNED_CHAR");
  static public final int UNSIGNED_ = 0x7;
  static public final DwAte UNSIGNED = new DwAte (0x7, "DwAte_UNSIGNED", "DW_ATE_unsigned", "UNSIGNED");
  static public final int UNSIGNED_CHAR_ = 0x8;
  static public final DwAte UNSIGNED_CHAR = new DwAte (0x8, "DwAte_UNSIGNED_CHAR", "DW_ATE_unsigned_char", "UNSIGNED_CHAR");
  static public final int IMAGINARY_FLOAT_ = 0x9;
  static public final DwAte IMAGINARY_FLOAT = new DwAte (0x9, "DwAte_IMAGINARY_FLOAT", "DW_ATE_imaginary_float", "IMAGINARY_FLOAT");
  static public final int PACKED_DECIMAL_ = 0xa;
  static public final DwAte PACKED_DECIMAL = new DwAte (0xa, "DwAte_PACKED_DECIMAL", "DW_ATE_packed_decimal", "PACKED_DECIMAL");
  static public final int NUMERIC_STRING_ = 0xb;
  static public final DwAte NUMERIC_STRING = new DwAte (0xb, "DwAte_NUMERIC_STRING", "DW_ATE_numeric_string", "NUMERIC_STRING");
  static public final int EDITED_ = 0xc;
  static public final DwAte EDITED = new DwAte (0xc, "DwAte_EDITED", "DW_ATE_edited", "EDITED");
  static public final int SIGNED_FIXED_ = 0xd;
  static public final DwAte SIGNED_FIXED = new DwAte (0xd, "DwAte_SIGNED_FIXED", "DW_ATE_signed_fixed", "SIGNED_FIXED");
  static public final int UNSIGNED_FIXED_ = 0xe;
  static public final DwAte UNSIGNED_FIXED = new DwAte (0xe, "DwAte_UNSIGNED_FIXED", "DW_ATE_unsigned_fixed", "UNSIGNED_FIXED");
  static public final int DECIMAL_FLOAT_ = 0xf;
  static public final DwAte DECIMAL_FLOAT = new DwAte (0xf, "DwAte_DECIMAL_FLOAT", "DW_ATE_decimal_float", "DECIMAL_FLOAT");
  static public final int LO_USER_ = 0x80;
  static public final DwAte LO_USER = new DwAte (0x80, "DwAte_LO_USER", "DW_ATE_lo_user", "LO_USER");
  static public final int HI_USER_ = 0xff;
  static public final DwAte HI_USER = new DwAte (0xff, "DwAte_HI_USER", "DW_ATE_hi_user", "HI_USER");

  /** Create a HashMap containing all the DwAte elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (VOID.enumName, VOID);
    map.put (ADDRESS.enumName, ADDRESS);
    map.put (BOOLEAN.enumName, BOOLEAN);
    map.put (COMPLEX_FLOAT.enumName, COMPLEX_FLOAT);
    map.put (FLOAT.enumName, FLOAT);
    map.put (SIGNED.enumName, SIGNED);
    map.put (SIGNED_CHAR.enumName, SIGNED_CHAR);
    map.put (UNSIGNED.enumName, UNSIGNED);
    map.put (UNSIGNED_CHAR.enumName, UNSIGNED_CHAR);
    map.put (IMAGINARY_FLOAT.enumName, IMAGINARY_FLOAT);
    map.put (PACKED_DECIMAL.enumName, PACKED_DECIMAL);
    map.put (NUMERIC_STRING.enumName, NUMERIC_STRING);
    map.put (EDITED.enumName, EDITED);
    map.put (SIGNED_FIXED.enumName, SIGNED_FIXED);
    map.put (UNSIGNED_FIXED.enumName, UNSIGNED_FIXED);
    map.put (DECIMAL_FLOAT.enumName, DECIMAL_FLOAT);
    map.put (LO_USER.enumName, LO_USER);
    map.put (HI_USER.enumName, HI_USER);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwAte object that matches the string.  */
  public static DwAte valueOf (String string)
  {
    return (DwAte)enumMap.get (string);
  }

  /** Return the DwAte object that matches the integer.  */
  public static DwAte valueOf (long i)
  {
    switch ((int)i) {
    case VOID_: return VOID;
    case ADDRESS_: return ADDRESS;
    case BOOLEAN_: return BOOLEAN;
    case COMPLEX_FLOAT_: return COMPLEX_FLOAT;
    case FLOAT_: return FLOAT;
    case SIGNED_: return SIGNED;
    case SIGNED_CHAR_: return SIGNED_CHAR;
    case UNSIGNED_: return UNSIGNED;
    case UNSIGNED_CHAR_: return UNSIGNED_CHAR;
    case IMAGINARY_FLOAT_: return IMAGINARY_FLOAT;
    case PACKED_DECIMAL_: return PACKED_DECIMAL;
    case NUMERIC_STRING_: return NUMERIC_STRING;
    case EDITED_: return EDITED;
    case SIGNED_FIXED_: return SIGNED_FIXED;
    case UNSIGNED_FIXED_: return UNSIGNED_FIXED;
    case DECIMAL_FLOAT_: return DECIMAL_FLOAT;
    case LO_USER_: return LO_USER;
    case HI_USER_: return HI_USER;
    default: return null;
    }
  }

  /** Return an array of all the DwAte elements.  */
  public static DwAte[] values ()
  {
    return (DwAte[]) enumMap.values ().toArray (new DwAte[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwAte c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwAte c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwAte c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwAte c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwAte c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
