package lib.dwfl;

public class DwDs
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwDs (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwDs))
      return false;
    return ((DwDs)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwDs rhs = (DwDs) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int UNSIGNED_ = 1;
  static public final DwDs UNSIGNED = new DwDs (1, "DwDs_UNSIGNED", "DW_DS_unsigned", "UNSIGNED");
  static public final int LEADING_OVERPUNCH_ = 2;
  static public final DwDs LEADING_OVERPUNCH = new DwDs (2, "DwDs_LEADING_OVERPUNCH", "DW_DS_leading_overpunch", "LEADING_OVERPUNCH");
  static public final int TRAILING_OVERPUNCH_ = 3;
  static public final DwDs TRAILING_OVERPUNCH = new DwDs (3, "DwDs_TRAILING_OVERPUNCH", "DW_DS_trailing_overpunch", "TRAILING_OVERPUNCH");
  static public final int LEADING_SEPARATE_ = 4;
  static public final DwDs LEADING_SEPARATE = new DwDs (4, "DwDs_LEADING_SEPARATE", "DW_DS_leading_separate", "LEADING_SEPARATE");
  static public final int TRAILING_SEPARATE_ = 5;
  static public final DwDs TRAILING_SEPARATE = new DwDs (5, "DwDs_TRAILING_SEPARATE", "DW_DS_trailing_separate", "TRAILING_SEPARATE");

  /** Create a HashMap containing all the DwDs elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (UNSIGNED.enumName, UNSIGNED);
    map.put (LEADING_OVERPUNCH.enumName, LEADING_OVERPUNCH);
    map.put (TRAILING_OVERPUNCH.enumName, TRAILING_OVERPUNCH);
    map.put (LEADING_SEPARATE.enumName, LEADING_SEPARATE);
    map.put (TRAILING_SEPARATE.enumName, TRAILING_SEPARATE);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwDs object that matches the string.  */
  public static DwDs valueOf (String string)
  {
    return (DwDs)enumMap.get (string);
  }

  /** Return the DwDs object that matches the integer.  */
  public static DwDs valueOf (long i)
  {
    switch ((int)i) {
    case UNSIGNED_: return UNSIGNED;
    case LEADING_OVERPUNCH_: return LEADING_OVERPUNCH;
    case TRAILING_OVERPUNCH_: return TRAILING_OVERPUNCH;
    case LEADING_SEPARATE_: return LEADING_SEPARATE;
    case TRAILING_SEPARATE_: return TRAILING_SEPARATE;
    default: return null;
    }
  }

  /** Return an array of all the DwDs elements.  */
  public static DwDs[] values ()
  {
    return (DwDs[]) enumMap.values ().toArray (new DwDs[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwDs c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwDs c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwDs c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwDs c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwDs c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
