package lib.dwfl;

public class DwDsc
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwDsc (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwDsc))
      return false;
    return ((DwDsc)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwDsc rhs = (DwDsc) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int LABEL_ = 0;
  static public final DwDsc LABEL = new DwDsc (0, "DwDsc_LABEL", "DW_DSC_label", "LABEL");
  static public final int RANGE_ = 1;
  static public final DwDsc RANGE = new DwDsc (1, "DwDsc_RANGE", "DW_DSC_range", "RANGE");

  /** Create a HashMap containing all the DwDsc elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (LABEL.enumName, LABEL);
    map.put (RANGE.enumName, RANGE);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwDsc object that matches the string.  */
  public static DwDsc valueOf (String string)
  {
    return (DwDsc)enumMap.get (string);
  }

  /** Return the DwDsc object that matches the integer.  */
  public static DwDsc valueOf (long i)
  {
    switch ((int)i) {
    case LABEL_: return LABEL;
    case RANGE_: return RANGE;
    default: return null;
    }
  }

  /** Return an array of all the DwDsc elements.  */
  public static DwDsc[] values ()
  {
    return (DwDsc[]) enumMap.values ().toArray (new DwDsc[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwDsc c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwDsc c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwDsc c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwDsc c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwDsc c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
