package lib.dwfl;

public class DwEnd
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwEnd (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwEnd))
      return false;
    return ((DwEnd)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwEnd rhs = (DwEnd) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int DEFAULT_ = 0;
  static public final DwEnd DEFAULT = new DwEnd (0, "DwEnd_DEFAULT", "DW_END_default", "DEFAULT");
  static public final int BIG_ = 1;
  static public final DwEnd BIG = new DwEnd (1, "DwEnd_BIG", "DW_END_big", "BIG");
  static public final int LITTLE_ = 2;
  static public final DwEnd LITTLE = new DwEnd (2, "DwEnd_LITTLE", "DW_END_little", "LITTLE");
  static public final int LO_USER_ = 0x40;
  static public final DwEnd LO_USER = new DwEnd (0x40, "DwEnd_LO_USER", "DW_END_lo_user", "LO_USER");
  static public final int HI_USER_ = 0xff;
  static public final DwEnd HI_USER = new DwEnd (0xff, "DwEnd_HI_USER", "DW_END_hi_user", "HI_USER");

  /** Create a HashMap containing all the DwEnd elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (DEFAULT.enumName, DEFAULT);
    map.put (BIG.enumName, BIG);
    map.put (LITTLE.enumName, LITTLE);
    map.put (LO_USER.enumName, LO_USER);
    map.put (HI_USER.enumName, HI_USER);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwEnd object that matches the string.  */
  public static DwEnd valueOf (String string)
  {
    return (DwEnd)enumMap.get (string);
  }

  /** Return the DwEnd object that matches the integer.  */
  public static DwEnd valueOf (long i)
  {
    switch ((int)i) {
    case DEFAULT_: return DEFAULT;
    case BIG_: return BIG;
    case LITTLE_: return LITTLE;
    case LO_USER_: return LO_USER;
    case HI_USER_: return HI_USER;
    default: return null;
    }
  }

  /** Return an array of all the DwEnd elements.  */
  public static DwEnd[] values ()
  {
    return (DwEnd[]) enumMap.values ().toArray (new DwEnd[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwEnd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwEnd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwEnd c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwEnd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwEnd c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
