package lib.dwfl;

public class DwInl
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwInl (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwInl))
      return false;
    return ((DwInl)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwInl rhs = (DwInl) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int NOT_INLINED_ = 0;
  static public final DwInl NOT_INLINED = new DwInl (0, "DwInl_NOT_INLINED", "DW_INL_not_inlined", "NOT_INLINED");
  static public final int INLINED_ = 1;
  static public final DwInl INLINED = new DwInl (1, "DwInl_INLINED", "DW_INL_inlined", "INLINED");
  static public final int DECLARED_NOT_INLINED_ = 2;
  static public final DwInl DECLARED_NOT_INLINED = new DwInl (2, "DwInl_DECLARED_NOT_INLINED", "DW_INL_declared_not_inlined", "DECLARED_NOT_INLINED");
  static public final int DECLARED_INLINED_ = 3;
  static public final DwInl DECLARED_INLINED = new DwInl (3, "DwInl_DECLARED_INLINED", "DW_INL_declared_inlined", "DECLARED_INLINED");

  /** Create a HashMap containing all the DwInl elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (NOT_INLINED.enumName, NOT_INLINED);
    map.put (INLINED.enumName, INLINED);
    map.put (DECLARED_NOT_INLINED.enumName, DECLARED_NOT_INLINED);
    map.put (DECLARED_INLINED.enumName, DECLARED_INLINED);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwInl object that matches the string.  */
  public static DwInl valueOf (String string)
  {
    return (DwInl)enumMap.get (string);
  }

  /** Return the DwInl object that matches the integer.  */
  public static DwInl valueOf (long i)
  {
    switch ((int)i) {
    case NOT_INLINED_: return NOT_INLINED;
    case INLINED_: return INLINED;
    case DECLARED_NOT_INLINED_: return DECLARED_NOT_INLINED;
    case DECLARED_INLINED_: return DECLARED_INLINED;
    default: return null;
    }
  }

  /** Return an array of all the DwInl elements.  */
  public static DwInl[] values ()
  {
    return (DwInl[]) enumMap.values ().toArray (new DwInl[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwInl c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwInl c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwInl c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwInl c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwInl c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
