package lib.dwfl;

public class DwOrd
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwOrd (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwOrd))
      return false;
    return ((DwOrd)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwOrd rhs = (DwOrd) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int ROW_MAJOR_ = 0;
  static public final DwOrd ROW_MAJOR = new DwOrd (0, "DwOrd_ROW_MAJOR", "DW_ORD_row_major", "ROW_MAJOR");
  static public final int COL_MAJOR_ = 1;
  static public final DwOrd COL_MAJOR = new DwOrd (1, "DwOrd_COL_MAJOR", "DW_ORD_col_major", "COL_MAJOR");

  /** Create a HashMap containing all the DwOrd elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (ROW_MAJOR.enumName, ROW_MAJOR);
    map.put (COL_MAJOR.enumName, COL_MAJOR);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwOrd object that matches the string.  */
  public static DwOrd valueOf (String string)
  {
    return (DwOrd)enumMap.get (string);
  }

  /** Return the DwOrd object that matches the integer.  */
  public static DwOrd valueOf (long i)
  {
    switch ((int)i) {
    case ROW_MAJOR_: return ROW_MAJOR;
    case COL_MAJOR_: return COL_MAJOR;
    default: return null;
    }
  }

  /** Return an array of all the DwOrd elements.  */
  public static DwOrd[] values ()
  {
    return (DwOrd[]) enumMap.values ().toArray (new DwOrd[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwOrd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwOrd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwOrd c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwOrd c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwOrd c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
