package lib.dwfl;

public class DwarfRegistersX86
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwarfRegistersX86 (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwarfRegistersX86))
      return false;
    return ((DwarfRegistersX86)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwarfRegistersX86 rhs = (DwarfRegistersX86) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int EAX_ = 0;
  static public final DwarfRegistersX86 EAX = new DwarfRegistersX86 (0, "DwarfRegistersX86_EAX", "EAX", "EAX");
  static public final int ECX_ = 1;
  static public final DwarfRegistersX86 ECX = new DwarfRegistersX86 (1, "DwarfRegistersX86_ECX", "ECX", "ECX");
  static public final int EDX_ = 2;
  static public final DwarfRegistersX86 EDX = new DwarfRegistersX86 (2, "DwarfRegistersX86_EDX", "EDX", "EDX");
  static public final int EBX_ = 3;
  static public final DwarfRegistersX86 EBX = new DwarfRegistersX86 (3, "DwarfRegistersX86_EBX", "EBX", "EBX");
  static public final int ESP_ = 4;
  static public final DwarfRegistersX86 ESP = new DwarfRegistersX86 (4, "DwarfRegistersX86_ESP", "ESP", "ESP");
  static public final int EBP_ = 5;
  static public final DwarfRegistersX86 EBP = new DwarfRegistersX86 (5, "DwarfRegistersX86_EBP", "EBP", "EBP");
  static public final int ESI_ = 6;
  static public final DwarfRegistersX86 ESI = new DwarfRegistersX86 (6, "DwarfRegistersX86_ESI", "ESI", "ESI");
  static public final int EDI_ = 7;
  static public final DwarfRegistersX86 EDI = new DwarfRegistersX86 (7, "DwarfRegistersX86_EDI", "EDI", "EDI");
  static public final int EIP_ = 8;
  static public final DwarfRegistersX86 EIP = new DwarfRegistersX86 (8, "DwarfRegistersX86_EIP", "EIP", "EIP");
  static public final int EFLAGS_ = 9;
  static public final DwarfRegistersX86 EFLAGS = new DwarfRegistersX86 (9, "DwarfRegistersX86_EFLAGS", "EFLAGS", "EFLAGS");
  static public final int TRAPNO_ = 10;
  static public final DwarfRegistersX86 TRAPNO = new DwarfRegistersX86 (10, "DwarfRegistersX86_TRAPNO", "TRAPNO", "TRAPNO");
  static public final int ST0_ = 11;
  static public final DwarfRegistersX86 ST0 = new DwarfRegistersX86 (11, "DwarfRegistersX86_ST0", "ST0", "ST0");
  static public final int ST1_ = 12;
  static public final DwarfRegistersX86 ST1 = new DwarfRegistersX86 (12, "DwarfRegistersX86_ST1", "ST1", "ST1");
  static public final int ST2_ = 13;
  static public final DwarfRegistersX86 ST2 = new DwarfRegistersX86 (13, "DwarfRegistersX86_ST2", "ST2", "ST2");
  static public final int ST3_ = 14;
  static public final DwarfRegistersX86 ST3 = new DwarfRegistersX86 (14, "DwarfRegistersX86_ST3", "ST3", "ST3");
  static public final int ST4_ = 15;
  static public final DwarfRegistersX86 ST4 = new DwarfRegistersX86 (15, "DwarfRegistersX86_ST4", "ST4", "ST4");
  static public final int ST5_ = 16;
  static public final DwarfRegistersX86 ST5 = new DwarfRegistersX86 (16, "DwarfRegistersX86_ST5", "ST5", "ST5");
  static public final int ST6_ = 17;
  static public final DwarfRegistersX86 ST6 = new DwarfRegistersX86 (17, "DwarfRegistersX86_ST6", "ST6", "ST6");
  static public final int ST7_ = 18;
  static public final DwarfRegistersX86 ST7 = new DwarfRegistersX86 (18, "DwarfRegistersX86_ST7", "ST7", "ST7");

  /** Create a HashMap containing all the DwarfRegistersX86 elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (EAX.enumName, EAX);
    map.put (ECX.enumName, ECX);
    map.put (EDX.enumName, EDX);
    map.put (EBX.enumName, EBX);
    map.put (ESP.enumName, ESP);
    map.put (EBP.enumName, EBP);
    map.put (ESI.enumName, ESI);
    map.put (EDI.enumName, EDI);
    map.put (EIP.enumName, EIP);
    map.put (EFLAGS.enumName, EFLAGS);
    map.put (TRAPNO.enumName, TRAPNO);
    map.put (ST0.enumName, ST0);
    map.put (ST1.enumName, ST1);
    map.put (ST2.enumName, ST2);
    map.put (ST3.enumName, ST3);
    map.put (ST4.enumName, ST4);
    map.put (ST5.enumName, ST5);
    map.put (ST6.enumName, ST6);
    map.put (ST7.enumName, ST7);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwarfRegistersX86 object that matches the string.  */
  public static DwarfRegistersX86 valueOf (String string)
  {
    return (DwarfRegistersX86)enumMap.get (string);
  }

  /** Return the DwarfRegistersX86 object that matches the integer.  */
  public static DwarfRegistersX86 valueOf (long i)
  {
    switch ((int)i) {
    case EAX_: return EAX;
    case ECX_: return ECX;
    case EDX_: return EDX;
    case EBX_: return EBX;
    case ESP_: return ESP;
    case EBP_: return EBP;
    case ESI_: return ESI;
    case EDI_: return EDI;
    case EIP_: return EIP;
    case EFLAGS_: return EFLAGS;
    case TRAPNO_: return TRAPNO;
    case ST0_: return ST0;
    case ST1_: return ST1;
    case ST2_: return ST2;
    case ST3_: return ST3;
    case ST4_: return ST4;
    case ST5_: return ST5;
    case ST6_: return ST6;
    case ST7_: return ST7;
    default: return null;
    }
  }

  /** Return an array of all the DwarfRegistersX86 elements.  */
  public static DwarfRegistersX86[] values ()
  {
    return (DwarfRegistersX86[]) enumMap.values ().toArray (new DwarfRegistersX86[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwarfRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwarfRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwarfRegistersX86 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwarfRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwarfRegistersX86 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
