package lib.dwfl;

/**
 *http://www.x86-64.org/viewvc/trunk/x86-64-ABI/low-level-sys-info.tex?revision=214&view=markup
 */
public class DwarfRegistersX8664
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwarfRegistersX8664 (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof DwarfRegistersX8664))
      return false;
    return ((DwarfRegistersX8664)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwarfRegistersX8664 rhs = (DwarfRegistersX8664) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int RAX_ = 0;
  static public final DwarfRegistersX8664 RAX = new DwarfRegistersX8664 (0, "DwarfRegistersX8664_RAX", "RAX", "RAX");
  static public final int RDX_ = 1;
  static public final DwarfRegistersX8664 RDX = new DwarfRegistersX8664 (1, "DwarfRegistersX8664_RDX", "RDX", "RDX");
  static public final int RCX_ = 2;
  static public final DwarfRegistersX8664 RCX = new DwarfRegistersX8664 (2, "DwarfRegistersX8664_RCX", "RCX", "RCX");
  static public final int RBX_ = 3;
  static public final DwarfRegistersX8664 RBX = new DwarfRegistersX8664 (3, "DwarfRegistersX8664_RBX", "RBX", "RBX");
  static public final int RSI_ = 4;
  static public final DwarfRegistersX8664 RSI = new DwarfRegistersX8664 (4, "DwarfRegistersX8664_RSI", "RSI", "RSI");
  static public final int RDI_ = 5;
  static public final DwarfRegistersX8664 RDI = new DwarfRegistersX8664 (5, "DwarfRegistersX8664_RDI", "RDI", "RDI");
  static public final int RBP_ = 6;
  static public final DwarfRegistersX8664 RBP = new DwarfRegistersX8664 (6, "DwarfRegistersX8664_RBP", "RBP", "RBP");
  static public final int RSP_ = 7;
  static public final DwarfRegistersX8664 RSP = new DwarfRegistersX8664 (7, "DwarfRegistersX8664_RSP", "RSP", "RSP");
  static public final int R8_ = 8;
  static public final DwarfRegistersX8664 R8 = new DwarfRegistersX8664 (8, "DwarfRegistersX8664_R8", "R8", "R8");
  static public final int R9_ = 9;
  static public final DwarfRegistersX8664 R9 = new DwarfRegistersX8664 (9, "DwarfRegistersX8664_R9", "R9", "R9");
  static public final int R10_ = 10;
  static public final DwarfRegistersX8664 R10 = new DwarfRegistersX8664 (10, "DwarfRegistersX8664_R10", "R10", "R10");
  static public final int R11_ = 11;
  static public final DwarfRegistersX8664 R11 = new DwarfRegistersX8664 (11, "DwarfRegistersX8664_R11", "R11", "R11");
  static public final int R12_ = 12;
  static public final DwarfRegistersX8664 R12 = new DwarfRegistersX8664 (12, "DwarfRegistersX8664_R12", "R12", "R12");
  static public final int R13_ = 13;
  static public final DwarfRegistersX8664 R13 = new DwarfRegistersX8664 (13, "DwarfRegistersX8664_R13", "R13", "R13");
  static public final int R14_ = 14;
  static public final DwarfRegistersX8664 R14 = new DwarfRegistersX8664 (14, "DwarfRegistersX8664_R14", "R14", "R14");
  static public final int R15_ = 15;
  static public final DwarfRegistersX8664 R15 = new DwarfRegistersX8664 (15, "DwarfRegistersX8664_R15", "R15", "R15");
  static public final int RIP_ = 16;
  static public final DwarfRegistersX8664 RIP = new DwarfRegistersX8664 (16, "DwarfRegistersX8664_RIP", "RIP", "RIP");
  static public final int XMM0_ = 17;
  static public final DwarfRegistersX8664 XMM0 = new DwarfRegistersX8664 (17, "DwarfRegistersX8664_XMM0", "XMM0", "XMM0");
  static public final int XMM1_ = 18;
  static public final DwarfRegistersX8664 XMM1 = new DwarfRegistersX8664 (18, "DwarfRegistersX8664_XMM1", "XMM1", "XMM1");
  static public final int XMM2_ = 19;
  static public final DwarfRegistersX8664 XMM2 = new DwarfRegistersX8664 (19, "DwarfRegistersX8664_XMM2", "XMM2", "XMM2");
  static public final int XMM3_ = 20;
  static public final DwarfRegistersX8664 XMM3 = new DwarfRegistersX8664 (20, "DwarfRegistersX8664_XMM3", "XMM3", "XMM3");
  static public final int XMM4_ = 21;
  static public final DwarfRegistersX8664 XMM4 = new DwarfRegistersX8664 (21, "DwarfRegistersX8664_XMM4", "XMM4", "XMM4");
  static public final int XMM5_ = 22;
  static public final DwarfRegistersX8664 XMM5 = new DwarfRegistersX8664 (22, "DwarfRegistersX8664_XMM5", "XMM5", "XMM5");
  static public final int XMM6_ = 23;
  static public final DwarfRegistersX8664 XMM6 = new DwarfRegistersX8664 (23, "DwarfRegistersX8664_XMM6", "XMM6", "XMM6");
  static public final int XMM7_ = 24;
  static public final DwarfRegistersX8664 XMM7 = new DwarfRegistersX8664 (24, "DwarfRegistersX8664_XMM7", "XMM7", "XMM7");
  static public final int XMM8_ = 25;
  static public final DwarfRegistersX8664 XMM8 = new DwarfRegistersX8664 (25, "DwarfRegistersX8664_XMM8", "XMM8", "XMM8");
  static public final int XMM9_ = 26;
  static public final DwarfRegistersX8664 XMM9 = new DwarfRegistersX8664 (26, "DwarfRegistersX8664_XMM9", "XMM9", "XMM9");
  static public final int XMM10_ = 27;
  static public final DwarfRegistersX8664 XMM10 = new DwarfRegistersX8664 (27, "DwarfRegistersX8664_XMM10", "XMM10", "XMM10");
  static public final int XMM11_ = 28;
  static public final DwarfRegistersX8664 XMM11 = new DwarfRegistersX8664 (28, "DwarfRegistersX8664_XMM11", "XMM11", "XMM11");
  static public final int XMM12_ = 29;
  static public final DwarfRegistersX8664 XMM12 = new DwarfRegistersX8664 (29, "DwarfRegistersX8664_XMM12", "XMM12", "XMM12");
  static public final int XMM13_ = 30;
  static public final DwarfRegistersX8664 XMM13 = new DwarfRegistersX8664 (30, "DwarfRegistersX8664_XMM13", "XMM13", "XMM13");
  static public final int XMM14_ = 31;
  static public final DwarfRegistersX8664 XMM14 = new DwarfRegistersX8664 (31, "DwarfRegistersX8664_XMM14", "XMM14", "XMM14");
  static public final int XMM15_ = 32;
  static public final DwarfRegistersX8664 XMM15 = new DwarfRegistersX8664 (32, "DwarfRegistersX8664_XMM15", "XMM15", "XMM15");
  static public final int ST0_ = 33;
  static public final DwarfRegistersX8664 ST0 = new DwarfRegistersX8664 (33, "DwarfRegistersX8664_ST0", "ST0", "ST0");
  static public final int ST1_ = 34;
  static public final DwarfRegistersX8664 ST1 = new DwarfRegistersX8664 (34, "DwarfRegistersX8664_ST1", "ST1", "ST1");
  static public final int ST2_ = 35;
  static public final DwarfRegistersX8664 ST2 = new DwarfRegistersX8664 (35, "DwarfRegistersX8664_ST2", "ST2", "ST2");
  static public final int ST3_ = 36;
  static public final DwarfRegistersX8664 ST3 = new DwarfRegistersX8664 (36, "DwarfRegistersX8664_ST3", "ST3", "ST3");
  static public final int ST4_ = 37;
  static public final DwarfRegistersX8664 ST4 = new DwarfRegistersX8664 (37, "DwarfRegistersX8664_ST4", "ST4", "ST4");
  static public final int ST5_ = 38;
  static public final DwarfRegistersX8664 ST5 = new DwarfRegistersX8664 (38, "DwarfRegistersX8664_ST5", "ST5", "ST5");
  static public final int ST6_ = 39;
  static public final DwarfRegistersX8664 ST6 = new DwarfRegistersX8664 (39, "DwarfRegistersX8664_ST6", "ST6", "ST6");
  static public final int ST7_ = 40;
  static public final DwarfRegistersX8664 ST7 = new DwarfRegistersX8664 (40, "DwarfRegistersX8664_ST7", "ST7", "ST7");
  static public final int MM0_ = 41;
  static public final DwarfRegistersX8664 MM0 = new DwarfRegistersX8664 (41, "DwarfRegistersX8664_MM0", "MM0", "MM0");
  static public final int MM1_ = 42;
  static public final DwarfRegistersX8664 MM1 = new DwarfRegistersX8664 (42, "DwarfRegistersX8664_MM1", "MM1", "MM1");
  static public final int MM2_ = 43;
  static public final DwarfRegistersX8664 MM2 = new DwarfRegistersX8664 (43, "DwarfRegistersX8664_MM2", "MM2", "MM2");
  static public final int MM3_ = 44;
  static public final DwarfRegistersX8664 MM3 = new DwarfRegistersX8664 (44, "DwarfRegistersX8664_MM3", "MM3", "MM3");
  static public final int MM4_ = 45;
  static public final DwarfRegistersX8664 MM4 = new DwarfRegistersX8664 (45, "DwarfRegistersX8664_MM4", "MM4", "MM4");
  static public final int MM5_ = 46;
  static public final DwarfRegistersX8664 MM5 = new DwarfRegistersX8664 (46, "DwarfRegistersX8664_MM5", "MM5", "MM5");
  static public final int MM6_ = 47;
  static public final DwarfRegistersX8664 MM6 = new DwarfRegistersX8664 (47, "DwarfRegistersX8664_MM6", "MM6", "MM6");
  static public final int MM7_ = 48;
  static public final DwarfRegistersX8664 MM7 = new DwarfRegistersX8664 (48, "DwarfRegistersX8664_MM7", "MM7", "MM7");
  static public final int RFLAGS_ = 49;
  static public final DwarfRegistersX8664 RFLAGS = new DwarfRegistersX8664 (49, "DwarfRegistersX8664_RFLAGS", "RFLAGS", "RFLAGS");
  static public final int ES_ = 50;
  static public final DwarfRegistersX8664 ES = new DwarfRegistersX8664 (50, "DwarfRegistersX8664_ES", "ES", "ES");
  static public final int CS_ = 51;
  static public final DwarfRegistersX8664 CS = new DwarfRegistersX8664 (51, "DwarfRegistersX8664_CS", "CS", "CS");
  static public final int SS_ = 52;
  static public final DwarfRegistersX8664 SS = new DwarfRegistersX8664 (52, "DwarfRegistersX8664_SS", "SS", "SS");
  static public final int DS_ = 53;
  static public final DwarfRegistersX8664 DS = new DwarfRegistersX8664 (53, "DwarfRegistersX8664_DS", "DS", "DS");
  static public final int FS_ = 54;
  static public final DwarfRegistersX8664 FS = new DwarfRegistersX8664 (54, "DwarfRegistersX8664_FS", "FS", "FS");
  /**
   * Reserved
   */
  static public final int GS_ = 55;
  static public final DwarfRegistersX8664 GS = new DwarfRegistersX8664 (55, "DwarfRegistersX8664_GS", "GS", "GS");
  static public final int FSBASE_ = 58;
  static public final DwarfRegistersX8664 FSBASE = new DwarfRegistersX8664 (58, "DwarfRegistersX8664_FSBASE", "FSBASE", "FSBASE");
  /**
   * Reserved
   */
  static public final int GSBASE_ = 59;
  static public final DwarfRegistersX8664 GSBASE = new DwarfRegistersX8664 (59, "DwarfRegistersX8664_GSBASE", "GSBASE", "GSBASE");
  static public final int TR_ = 62;
  static public final DwarfRegistersX8664 TR = new DwarfRegistersX8664 (62, "DwarfRegistersX8664_TR", "TR", "TR");
  static public final int LDTR_ = 63;
  static public final DwarfRegistersX8664 LDTR = new DwarfRegistersX8664 (63, "DwarfRegistersX8664_LDTR", "LDTR", "LDTR");
  static public final int MXCSR_ = 64;
  static public final DwarfRegistersX8664 MXCSR = new DwarfRegistersX8664 (64, "DwarfRegistersX8664_MXCSR", "MXCSR", "MXCSR");
  static public final int FCW_ = 65;
  static public final DwarfRegistersX8664 FCW = new DwarfRegistersX8664 (65, "DwarfRegistersX8664_FCW", "FCW", "FCW");
  static public final int FSW_ = 66;
  static public final DwarfRegistersX8664 FSW = new DwarfRegistersX8664 (66, "DwarfRegistersX8664_FSW", "FSW", "FSW");

  /** Create a HashMap containing all the DwarfRegistersX8664 elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (RAX.enumName, RAX);
    map.put (RDX.enumName, RDX);
    map.put (RCX.enumName, RCX);
    map.put (RBX.enumName, RBX);
    map.put (RSI.enumName, RSI);
    map.put (RDI.enumName, RDI);
    map.put (RBP.enumName, RBP);
    map.put (RSP.enumName, RSP);
    map.put (R8.enumName, R8);
    map.put (R9.enumName, R9);
    map.put (R10.enumName, R10);
    map.put (R11.enumName, R11);
    map.put (R12.enumName, R12);
    map.put (R13.enumName, R13);
    map.put (R14.enumName, R14);
    map.put (R15.enumName, R15);
    map.put (RIP.enumName, RIP);
    map.put (XMM0.enumName, XMM0);
    map.put (XMM1.enumName, XMM1);
    map.put (XMM2.enumName, XMM2);
    map.put (XMM3.enumName, XMM3);
    map.put (XMM4.enumName, XMM4);
    map.put (XMM5.enumName, XMM5);
    map.put (XMM6.enumName, XMM6);
    map.put (XMM7.enumName, XMM7);
    map.put (XMM8.enumName, XMM8);
    map.put (XMM9.enumName, XMM9);
    map.put (XMM10.enumName, XMM10);
    map.put (XMM11.enumName, XMM11);
    map.put (XMM12.enumName, XMM12);
    map.put (XMM13.enumName, XMM13);
    map.put (XMM14.enumName, XMM14);
    map.put (XMM15.enumName, XMM15);
    map.put (ST0.enumName, ST0);
    map.put (ST1.enumName, ST1);
    map.put (ST2.enumName, ST2);
    map.put (ST3.enumName, ST3);
    map.put (ST4.enumName, ST4);
    map.put (ST5.enumName, ST5);
    map.put (ST6.enumName, ST6);
    map.put (ST7.enumName, ST7);
    map.put (MM0.enumName, MM0);
    map.put (MM1.enumName, MM1);
    map.put (MM2.enumName, MM2);
    map.put (MM3.enumName, MM3);
    map.put (MM4.enumName, MM4);
    map.put (MM5.enumName, MM5);
    map.put (MM6.enumName, MM6);
    map.put (MM7.enumName, MM7);
    map.put (RFLAGS.enumName, RFLAGS);
    map.put (ES.enumName, ES);
    map.put (CS.enumName, CS);
    map.put (SS.enumName, SS);
    map.put (DS.enumName, DS);
    map.put (FS.enumName, FS);
    map.put (GS.enumName, GS);
    map.put (FSBASE.enumName, FSBASE);
    map.put (GSBASE.enumName, GSBASE);
    map.put (TR.enumName, TR);
    map.put (LDTR.enumName, LDTR);
    map.put (MXCSR.enumName, MXCSR);
    map.put (FCW.enumName, FCW);
    map.put (FSW.enumName, FSW);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwarfRegistersX8664 object that matches the string.  */
  public static DwarfRegistersX8664 valueOf (String string)
  {
    return (DwarfRegistersX8664)enumMap.get (string);
  }

  /** Return the DwarfRegistersX8664 object that matches the integer.  */
  public static DwarfRegistersX8664 valueOf (long i)
  {
    switch ((int)i) {
    case RAX_: return RAX;
    case RDX_: return RDX;
    case RCX_: return RCX;
    case RBX_: return RBX;
    case RSI_: return RSI;
    case RDI_: return RDI;
    case RBP_: return RBP;
    case RSP_: return RSP;
    case R8_: return R8;
    case R9_: return R9;
    case R10_: return R10;
    case R11_: return R11;
    case R12_: return R12;
    case R13_: return R13;
    case R14_: return R14;
    case R15_: return R15;
    case RIP_: return RIP;
    case XMM0_: return XMM0;
    case XMM1_: return XMM1;
    case XMM2_: return XMM2;
    case XMM3_: return XMM3;
    case XMM4_: return XMM4;
    case XMM5_: return XMM5;
    case XMM6_: return XMM6;
    case XMM7_: return XMM7;
    case XMM8_: return XMM8;
    case XMM9_: return XMM9;
    case XMM10_: return XMM10;
    case XMM11_: return XMM11;
    case XMM12_: return XMM12;
    case XMM13_: return XMM13;
    case XMM14_: return XMM14;
    case XMM15_: return XMM15;
    case ST0_: return ST0;
    case ST1_: return ST1;
    case ST2_: return ST2;
    case ST3_: return ST3;
    case ST4_: return ST4;
    case ST5_: return ST5;
    case ST6_: return ST6;
    case ST7_: return ST7;
    case MM0_: return MM0;
    case MM1_: return MM1;
    case MM2_: return MM2;
    case MM3_: return MM3;
    case MM4_: return MM4;
    case MM5_: return MM5;
    case MM6_: return MM6;
    case MM7_: return MM7;
    case RFLAGS_: return RFLAGS;
    case ES_: return ES;
    case CS_: return CS;
    case SS_: return SS;
    case DS_: return DS;
    case FS_: return FS;
    case GS_: return GS;
    case FSBASE_: return FSBASE;
    case GSBASE_: return GSBASE;
    case TR_: return TR;
    case LDTR_: return LDTR;
    case MXCSR_: return MXCSR;
    case FCW_: return FCW;
    case FSW_: return FSW;
    default: return null;
    }
  }

  /** Return an array of all the DwarfRegistersX8664 elements.  */
  public static DwarfRegistersX8664[] values ()
  {
    return (DwarfRegistersX8664[]) enumMap.values ().toArray (new DwarfRegistersX8664[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwarfRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwarfRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwarfRegistersX8664 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwarfRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwarfRegistersX8664 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
