package lib.unwind;

public class ByteOrder
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private ByteOrder (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof ByteOrder))
      return false;
    return ((ByteOrder)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    ByteOrder rhs = (ByteOrder) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int DEFAULT_ = 0;
  static public final ByteOrder DEFAULT = new ByteOrder (0, "ByteOrder_DEFAULT", "DEFAULT", "DEFAULT");
  static public final int BIG_ = 1;
  static public final ByteOrder BIG = new ByteOrder (1, "ByteOrder_BIG", "BIG", "BIG");
  static public final int LITTLE_ = 2;
  static public final ByteOrder LITTLE = new ByteOrder (2, "ByteOrder_LITTLE", "LITTLE", "LITTLE");

  /** Create a HashMap containing all the ByteOrder elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (DEFAULT.enumName, DEFAULT);
    map.put (BIG.enumName, BIG);
    map.put (LITTLE.enumName, LITTLE);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the ByteOrder object that matches the string.  */
  public static ByteOrder valueOf (String string)
  {
    return (ByteOrder)enumMap.get (string);
  }

  /** Return the ByteOrder object that matches the integer.  */
  public static ByteOrder valueOf (long i)
  {
    switch ((int)i) {
    case DEFAULT_: return DEFAULT;
    case BIG_: return BIG;
    case LITTLE_: return LITTLE;
    default: return null;
    }
  }

  /** Return an array of all the ByteOrder elements.  */
  public static ByteOrder[] values ()
  {
    return (ByteOrder[]) enumMap.values ().toArray (new ByteOrder[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    ByteOrder c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    ByteOrder c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    ByteOrder c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    ByteOrder c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    ByteOrder c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
