package lib.unwind;

public class CachingPolicy
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private CachingPolicy (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof CachingPolicy))
      return false;
    return ((CachingPolicy)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    CachingPolicy rhs = (CachingPolicy) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int UNW_CACHE_NONE_ = 0;
  static public final CachingPolicy UNW_CACHE_NONE = new CachingPolicy (0, "CachingPolicy_UNW_CACHE_NONE", "UNW CACHE NONE", "UNW_CACHE_NONE");
  static public final int UNW_CACHE_GLOBAL_ = 1;
  static public final CachingPolicy UNW_CACHE_GLOBAL = new CachingPolicy (1, "CachingPolicy_UNW_CACHE_GLOBAL", "UNW CACHE GLOBAL", "UNW_CACHE_GLOBAL");
  static public final int UNW_CACHE_PER_THREAD_ = 2;
  static public final CachingPolicy UNW_CACHE_PER_THREAD = new CachingPolicy (2, "CachingPolicy_UNW_CACHE_PER_THREAD", "UNW CACHE PER THREAD", "UNW_CACHE_PER_THREAD");

  /** Create a HashMap containing all the CachingPolicy elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (UNW_CACHE_NONE.enumName, UNW_CACHE_NONE);
    map.put (UNW_CACHE_GLOBAL.enumName, UNW_CACHE_GLOBAL);
    map.put (UNW_CACHE_PER_THREAD.enumName, UNW_CACHE_PER_THREAD);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the CachingPolicy object that matches the string.  */
  public static CachingPolicy valueOf (String string)
  {
    return (CachingPolicy)enumMap.get (string);
  }

  /** Return the CachingPolicy object that matches the integer.  */
  public static CachingPolicy valueOf (long i)
  {
    switch ((int)i) {
    case UNW_CACHE_NONE_: return UNW_CACHE_NONE;
    case UNW_CACHE_GLOBAL_: return UNW_CACHE_GLOBAL;
    case UNW_CACHE_PER_THREAD_: return UNW_CACHE_PER_THREAD;
    default: return null;
    }
  }

  /** Return an array of all the CachingPolicy elements.  */
  public static CachingPolicy[] values ()
  {
    return (CachingPolicy[]) enumMap.values ().toArray (new CachingPolicy[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    CachingPolicy c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    CachingPolicy c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    CachingPolicy c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    CachingPolicy c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    CachingPolicy c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
