package lib.unwind;

public class Error
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private Error (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof Error))
      return false;
    return ((Error)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    Error rhs = (Error) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int UNW_ESUCCESS_ = 0;
  static public final Error UNW_ESUCCESS = new Error (0, "Error_UNW_ESUCCESS", "UNW ESUCCESS", "UNW_ESUCCESS");
  static public final int UNW_EUNSPEC_ = 1;
  static public final Error UNW_EUNSPEC = new Error (1, "Error_UNW_EUNSPEC", "UNW EUNSPEC", "UNW_EUNSPEC");
  static public final int UNW_ENOMEM_ = 2;
  static public final Error UNW_ENOMEM = new Error (2, "Error_UNW_ENOMEM", "UNW ENOMEM", "UNW_ENOMEM");
  static public final int UNW_EBADREG_ = 3;
  static public final Error UNW_EBADREG = new Error (3, "Error_UNW_EBADREG", "UNW EBADREG", "UNW_EBADREG");
  static public final int UNW_EREADONLYREG_ = 4;
  static public final Error UNW_EREADONLYREG = new Error (4, "Error_UNW_EREADONLYREG", "UNW EREADONLYREG", "UNW_EREADONLYREG");
  static public final int UNW_ESTOPUNWIND_ = 5;
  static public final Error UNW_ESTOPUNWIND = new Error (5, "Error_UNW_ESTOPUNWIND", "UNW ESTOPUNWIND", "UNW_ESTOPUNWIND");
  static public final int UNW_EINVALIDIP_ = 6;
  static public final Error UNW_EINVALIDIP = new Error (6, "Error_UNW_EINVALIDIP", "UNW EINVALIDIP", "UNW_EINVALIDIP");
  static public final int UNW_EBADFRAME_ = 7;
  static public final Error UNW_EBADFRAME = new Error (7, "Error_UNW_EBADFRAME", "UNW EBADFRAME", "UNW_EBADFRAME");
  static public final int UNW_EINVAL_ = 8;
  static public final Error UNW_EINVAL = new Error (8, "Error_UNW_EINVAL", "UNW EINVAL", "UNW_EINVAL");
  static public final int UNW_EBADVERSION_ = 9;
  static public final Error UNW_EBADVERSION = new Error (9, "Error_UNW_EBADVERSION", "UNW EBADVERSION", "UNW_EBADVERSION");
  static public final int UNW_ENOINFO_ = 10;
  static public final Error UNW_ENOINFO = new Error (10, "Error_UNW_ENOINFO", "UNW ENOINFO", "UNW_ENOINFO");

  /** Create a HashMap containing all the Error elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (UNW_ESUCCESS.enumName, UNW_ESUCCESS);
    map.put (UNW_EUNSPEC.enumName, UNW_EUNSPEC);
    map.put (UNW_ENOMEM.enumName, UNW_ENOMEM);
    map.put (UNW_EBADREG.enumName, UNW_EBADREG);
    map.put (UNW_EREADONLYREG.enumName, UNW_EREADONLYREG);
    map.put (UNW_ESTOPUNWIND.enumName, UNW_ESTOPUNWIND);
    map.put (UNW_EINVALIDIP.enumName, UNW_EINVALIDIP);
    map.put (UNW_EBADFRAME.enumName, UNW_EBADFRAME);
    map.put (UNW_EINVAL.enumName, UNW_EINVAL);
    map.put (UNW_EBADVERSION.enumName, UNW_EBADVERSION);
    map.put (UNW_ENOINFO.enumName, UNW_ENOINFO);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the Error object that matches the string.  */
  public static Error valueOf (String string)
  {
    return (Error)enumMap.get (string);
  }

  /** Return the Error object that matches the integer.  */
  public static Error valueOf (long i)
  {
    switch ((int)i) {
    case UNW_ESUCCESS_: return UNW_ESUCCESS;
    case UNW_EUNSPEC_: return UNW_EUNSPEC;
    case UNW_ENOMEM_: return UNW_ENOMEM;
    case UNW_EBADREG_: return UNW_EBADREG;
    case UNW_EREADONLYREG_: return UNW_EREADONLYREG;
    case UNW_ESTOPUNWIND_: return UNW_ESTOPUNWIND;
    case UNW_EINVALIDIP_: return UNW_EINVALIDIP;
    case UNW_EBADFRAME_: return UNW_EBADFRAME;
    case UNW_EINVAL_: return UNW_EINVAL;
    case UNW_EBADVERSION_: return UNW_EBADVERSION;
    case UNW_ENOINFO_: return UNW_ENOINFO;
    default: return null;
    }
  }

  /** Return an array of all the Error elements.  */
  public static Error[] values ()
  {
    return (Error[]) enumMap.values ().toArray (new Error[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    Error c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    Error c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    Error c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    Error c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    Error c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
