package lib.unwind;

public class UnwindRegistersPPC64
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private UnwindRegistersPPC64 (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof UnwindRegistersPPC64))
      return false;
    return ((UnwindRegistersPPC64)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    UnwindRegistersPPC64 rhs = (UnwindRegistersPPC64) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int R0_ = 0;
  static public final UnwindRegistersPPC64 R0 = new UnwindRegistersPPC64 (0, "UnwindRegistersPPC64_R0", "R0", "R0");
  static public final int R1_ = 1;
  static public final UnwindRegistersPPC64 R1 = new UnwindRegistersPPC64 (1, "UnwindRegistersPPC64_R1", "R1", "R1");
  static public final int R2_ = 2;
  static public final UnwindRegistersPPC64 R2 = new UnwindRegistersPPC64 (2, "UnwindRegistersPPC64_R2", "R2", "R2");
  static public final int R3_ = 3;
  static public final UnwindRegistersPPC64 R3 = new UnwindRegistersPPC64 (3, "UnwindRegistersPPC64_R3", "R3", "R3");
  static public final int R4_ = 4;
  static public final UnwindRegistersPPC64 R4 = new UnwindRegistersPPC64 (4, "UnwindRegistersPPC64_R4", "R4", "R4");
  static public final int R5_ = 5;
  static public final UnwindRegistersPPC64 R5 = new UnwindRegistersPPC64 (5, "UnwindRegistersPPC64_R5", "R5", "R5");
  static public final int R6_ = 6;
  static public final UnwindRegistersPPC64 R6 = new UnwindRegistersPPC64 (6, "UnwindRegistersPPC64_R6", "R6", "R6");
  static public final int R7_ = 7;
  static public final UnwindRegistersPPC64 R7 = new UnwindRegistersPPC64 (7, "UnwindRegistersPPC64_R7", "R7", "R7");
  static public final int R8_ = 8;
  static public final UnwindRegistersPPC64 R8 = new UnwindRegistersPPC64 (8, "UnwindRegistersPPC64_R8", "R8", "R8");
  static public final int R9_ = 9;
  static public final UnwindRegistersPPC64 R9 = new UnwindRegistersPPC64 (9, "UnwindRegistersPPC64_R9", "R9", "R9");
  static public final int R10_ = 10;
  static public final UnwindRegistersPPC64 R10 = new UnwindRegistersPPC64 (10, "UnwindRegistersPPC64_R10", "R10", "R10");
  static public final int R11_ = 11;
  static public final UnwindRegistersPPC64 R11 = new UnwindRegistersPPC64 (11, "UnwindRegistersPPC64_R11", "R11", "R11");
  static public final int R12_ = 12;
  static public final UnwindRegistersPPC64 R12 = new UnwindRegistersPPC64 (12, "UnwindRegistersPPC64_R12", "R12", "R12");
  static public final int R13_ = 13;
  static public final UnwindRegistersPPC64 R13 = new UnwindRegistersPPC64 (13, "UnwindRegistersPPC64_R13", "R13", "R13");
  static public final int R14_ = 14;
  static public final UnwindRegistersPPC64 R14 = new UnwindRegistersPPC64 (14, "UnwindRegistersPPC64_R14", "R14", "R14");
  static public final int R15_ = 15;
  static public final UnwindRegistersPPC64 R15 = new UnwindRegistersPPC64 (15, "UnwindRegistersPPC64_R15", "R15", "R15");
  static public final int R16_ = 16;
  static public final UnwindRegistersPPC64 R16 = new UnwindRegistersPPC64 (16, "UnwindRegistersPPC64_R16", "R16", "R16");
  static public final int R17_ = 17;
  static public final UnwindRegistersPPC64 R17 = new UnwindRegistersPPC64 (17, "UnwindRegistersPPC64_R17", "R17", "R17");
  static public final int R18_ = 18;
  static public final UnwindRegistersPPC64 R18 = new UnwindRegistersPPC64 (18, "UnwindRegistersPPC64_R18", "R18", "R18");
  static public final int R19_ = 19;
  static public final UnwindRegistersPPC64 R19 = new UnwindRegistersPPC64 (19, "UnwindRegistersPPC64_R19", "R19", "R19");
  static public final int R20_ = 20;
  static public final UnwindRegistersPPC64 R20 = new UnwindRegistersPPC64 (20, "UnwindRegistersPPC64_R20", "R20", "R20");
  static public final int R21_ = 21;
  static public final UnwindRegistersPPC64 R21 = new UnwindRegistersPPC64 (21, "UnwindRegistersPPC64_R21", "R21", "R21");
  static public final int R22_ = 22;
  static public final UnwindRegistersPPC64 R22 = new UnwindRegistersPPC64 (22, "UnwindRegistersPPC64_R22", "R22", "R22");
  static public final int R23_ = 23;
  static public final UnwindRegistersPPC64 R23 = new UnwindRegistersPPC64 (23, "UnwindRegistersPPC64_R23", "R23", "R23");
  static public final int R24_ = 24;
  static public final UnwindRegistersPPC64 R24 = new UnwindRegistersPPC64 (24, "UnwindRegistersPPC64_R24", "R24", "R24");
  static public final int R25_ = 25;
  static public final UnwindRegistersPPC64 R25 = new UnwindRegistersPPC64 (25, "UnwindRegistersPPC64_R25", "R25", "R25");
  static public final int R26_ = 26;
  static public final UnwindRegistersPPC64 R26 = new UnwindRegistersPPC64 (26, "UnwindRegistersPPC64_R26", "R26", "R26");
  static public final int R27_ = 27;
  static public final UnwindRegistersPPC64 R27 = new UnwindRegistersPPC64 (27, "UnwindRegistersPPC64_R27", "R27", "R27");
  static public final int R28_ = 28;
  static public final UnwindRegistersPPC64 R28 = new UnwindRegistersPPC64 (28, "UnwindRegistersPPC64_R28", "R28", "R28");
  static public final int R29_ = 29;
  static public final UnwindRegistersPPC64 R29 = new UnwindRegistersPPC64 (29, "UnwindRegistersPPC64_R29", "R29", "R29");
  static public final int R30_ = 30;
  static public final UnwindRegistersPPC64 R30 = new UnwindRegistersPPC64 (30, "UnwindRegistersPPC64_R30", "R30", "R30");
  static public final int R31_ = 31;
  static public final UnwindRegistersPPC64 R31 = new UnwindRegistersPPC64 (31, "UnwindRegistersPPC64_R31", "R31", "R31");
  static public final int F0_ = 32;
  static public final UnwindRegistersPPC64 F0 = new UnwindRegistersPPC64 (32, "UnwindRegistersPPC64_F0", "F0", "F0");
  static public final int F1_ = 33;
  static public final UnwindRegistersPPC64 F1 = new UnwindRegistersPPC64 (33, "UnwindRegistersPPC64_F1", "F1", "F1");
  static public final int F2_ = 34;
  static public final UnwindRegistersPPC64 F2 = new UnwindRegistersPPC64 (34, "UnwindRegistersPPC64_F2", "F2", "F2");
  static public final int F3_ = 35;
  static public final UnwindRegistersPPC64 F3 = new UnwindRegistersPPC64 (35, "UnwindRegistersPPC64_F3", "F3", "F3");
  static public final int F4_ = 36;
  static public final UnwindRegistersPPC64 F4 = new UnwindRegistersPPC64 (36, "UnwindRegistersPPC64_F4", "F4", "F4");
  static public final int F5_ = 37;
  static public final UnwindRegistersPPC64 F5 = new UnwindRegistersPPC64 (37, "UnwindRegistersPPC64_F5", "F5", "F5");
  static public final int F6_ = 38;
  static public final UnwindRegistersPPC64 F6 = new UnwindRegistersPPC64 (38, "UnwindRegistersPPC64_F6", "F6", "F6");
  static public final int F7_ = 39;
  static public final UnwindRegistersPPC64 F7 = new UnwindRegistersPPC64 (39, "UnwindRegistersPPC64_F7", "F7", "F7");
  static public final int F8_ = 40;
  static public final UnwindRegistersPPC64 F8 = new UnwindRegistersPPC64 (40, "UnwindRegistersPPC64_F8", "F8", "F8");
  static public final int F9_ = 41;
  static public final UnwindRegistersPPC64 F9 = new UnwindRegistersPPC64 (41, "UnwindRegistersPPC64_F9", "F9", "F9");
  static public final int F10_ = 42;
  static public final UnwindRegistersPPC64 F10 = new UnwindRegistersPPC64 (42, "UnwindRegistersPPC64_F10", "F10", "F10");
  static public final int F11_ = 43;
  static public final UnwindRegistersPPC64 F11 = new UnwindRegistersPPC64 (43, "UnwindRegistersPPC64_F11", "F11", "F11");
  static public final int F12_ = 44;
  static public final UnwindRegistersPPC64 F12 = new UnwindRegistersPPC64 (44, "UnwindRegistersPPC64_F12", "F12", "F12");
  static public final int F13_ = 45;
  static public final UnwindRegistersPPC64 F13 = new UnwindRegistersPPC64 (45, "UnwindRegistersPPC64_F13", "F13", "F13");
  static public final int F14_ = 46;
  static public final UnwindRegistersPPC64 F14 = new UnwindRegistersPPC64 (46, "UnwindRegistersPPC64_F14", "F14", "F14");
  static public final int F15_ = 47;
  static public final UnwindRegistersPPC64 F15 = new UnwindRegistersPPC64 (47, "UnwindRegistersPPC64_F15", "F15", "F15");
  static public final int F16_ = 48;
  static public final UnwindRegistersPPC64 F16 = new UnwindRegistersPPC64 (48, "UnwindRegistersPPC64_F16", "F16", "F16");
  static public final int F17_ = 49;
  static public final UnwindRegistersPPC64 F17 = new UnwindRegistersPPC64 (49, "UnwindRegistersPPC64_F17", "F17", "F17");
  static public final int F18_ = 50;
  static public final UnwindRegistersPPC64 F18 = new UnwindRegistersPPC64 (50, "UnwindRegistersPPC64_F18", "F18", "F18");
  static public final int F19_ = 51;
  static public final UnwindRegistersPPC64 F19 = new UnwindRegistersPPC64 (51, "UnwindRegistersPPC64_F19", "F19", "F19");
  static public final int F20_ = 52;
  static public final UnwindRegistersPPC64 F20 = new UnwindRegistersPPC64 (52, "UnwindRegistersPPC64_F20", "F20", "F20");
  static public final int F21_ = 53;
  static public final UnwindRegistersPPC64 F21 = new UnwindRegistersPPC64 (53, "UnwindRegistersPPC64_F21", "F21", "F21");
  static public final int F22_ = 54;
  static public final UnwindRegistersPPC64 F22 = new UnwindRegistersPPC64 (54, "UnwindRegistersPPC64_F22", "F22", "F22");
  static public final int F23_ = 55;
  static public final UnwindRegistersPPC64 F23 = new UnwindRegistersPPC64 (55, "UnwindRegistersPPC64_F23", "F23", "F23");
  static public final int F24_ = 56;
  static public final UnwindRegistersPPC64 F24 = new UnwindRegistersPPC64 (56, "UnwindRegistersPPC64_F24", "F24", "F24");
  static public final int F25_ = 57;
  static public final UnwindRegistersPPC64 F25 = new UnwindRegistersPPC64 (57, "UnwindRegistersPPC64_F25", "F25", "F25");
  static public final int F26_ = 58;
  static public final UnwindRegistersPPC64 F26 = new UnwindRegistersPPC64 (58, "UnwindRegistersPPC64_F26", "F26", "F26");
  static public final int F27_ = 59;
  static public final UnwindRegistersPPC64 F27 = new UnwindRegistersPPC64 (59, "UnwindRegistersPPC64_F27", "F27", "F27");
  static public final int F28_ = 60;
  static public final UnwindRegistersPPC64 F28 = new UnwindRegistersPPC64 (60, "UnwindRegistersPPC64_F28", "F28", "F28");
  static public final int F29_ = 61;
  static public final UnwindRegistersPPC64 F29 = new UnwindRegistersPPC64 (61, "UnwindRegistersPPC64_F29", "F29", "F29");
  static public final int F30_ = 62;
  static public final UnwindRegistersPPC64 F30 = new UnwindRegistersPPC64 (62, "UnwindRegistersPPC64_F30", "F30", "F30");
  static public final int F31_ = 63;
  static public final UnwindRegistersPPC64 F31 = new UnwindRegistersPPC64 (63, "UnwindRegistersPPC64_F31", "F31", "F31");
  static public final int LR_ = 65;
  static public final UnwindRegistersPPC64 LR = new UnwindRegistersPPC64 (65, "UnwindRegistersPPC64_LR", "LR", "LR");
  static public final int CTR_ = 66;
  static public final UnwindRegistersPPC64 CTR = new UnwindRegistersPPC64 (66, "UnwindRegistersPPC64_CTR", "CTR", "CTR");
  static public final int ARG_POINTER_ = 67;
  static public final UnwindRegistersPPC64 ARG_POINTER = new UnwindRegistersPPC64 (67, "UnwindRegistersPPC64_ARG_POINTER", "ARG POINTER", "ARG_POINTER");
  static public final int CR0_ = 68;
  static public final UnwindRegistersPPC64 CR0 = new UnwindRegistersPPC64 (68, "UnwindRegistersPPC64_CR0", "CR0", "CR0");
  static public final int CR1_ = 69;
  static public final UnwindRegistersPPC64 CR1 = new UnwindRegistersPPC64 (69, "UnwindRegistersPPC64_CR1", "CR1", "CR1");
  static public final int CR2_ = 70;
  static public final UnwindRegistersPPC64 CR2 = new UnwindRegistersPPC64 (70, "UnwindRegistersPPC64_CR2", "CR2", "CR2");
  static public final int CR3_ = 71;
  static public final UnwindRegistersPPC64 CR3 = new UnwindRegistersPPC64 (71, "UnwindRegistersPPC64_CR3", "CR3", "CR3");
  static public final int CR4_ = 72;
  static public final UnwindRegistersPPC64 CR4 = new UnwindRegistersPPC64 (72, "UnwindRegistersPPC64_CR4", "CR4", "CR4");
  static public final int CR5_ = 73;
  static public final UnwindRegistersPPC64 CR5 = new UnwindRegistersPPC64 (73, "UnwindRegistersPPC64_CR5", "CR5", "CR5");
  static public final int CR6_ = 74;
  static public final UnwindRegistersPPC64 CR6 = new UnwindRegistersPPC64 (74, "UnwindRegistersPPC64_CR6", "CR6", "CR6");
  static public final int CR7_ = 75;
  static public final UnwindRegistersPPC64 CR7 = new UnwindRegistersPPC64 (75, "UnwindRegistersPPC64_CR7", "CR7", "CR7");
  static public final int XER_ = 76;
  static public final UnwindRegistersPPC64 XER = new UnwindRegistersPPC64 (76, "UnwindRegistersPPC64_XER", "XER", "XER");
  static public final int V0_ = 77;
  static public final UnwindRegistersPPC64 V0 = new UnwindRegistersPPC64 (77, "UnwindRegistersPPC64_V0", "V0", "V0");
  static public final int V1_ = 78;
  static public final UnwindRegistersPPC64 V1 = new UnwindRegistersPPC64 (78, "UnwindRegistersPPC64_V1", "V1", "V1");
  static public final int V2_ = 79;
  static public final UnwindRegistersPPC64 V2 = new UnwindRegistersPPC64 (79, "UnwindRegistersPPC64_V2", "V2", "V2");
  static public final int V3_ = 80;
  static public final UnwindRegistersPPC64 V3 = new UnwindRegistersPPC64 (80, "UnwindRegistersPPC64_V3", "V3", "V3");
  static public final int V4_ = 81;
  static public final UnwindRegistersPPC64 V4 = new UnwindRegistersPPC64 (81, "UnwindRegistersPPC64_V4", "V4", "V4");
  static public final int V5_ = 82;
  static public final UnwindRegistersPPC64 V5 = new UnwindRegistersPPC64 (82, "UnwindRegistersPPC64_V5", "V5", "V5");
  static public final int V6_ = 83;
  static public final UnwindRegistersPPC64 V6 = new UnwindRegistersPPC64 (83, "UnwindRegistersPPC64_V6", "V6", "V6");
  static public final int V7_ = 84;
  static public final UnwindRegistersPPC64 V7 = new UnwindRegistersPPC64 (84, "UnwindRegistersPPC64_V7", "V7", "V7");
  static public final int V8_ = 85;
  static public final UnwindRegistersPPC64 V8 = new UnwindRegistersPPC64 (85, "UnwindRegistersPPC64_V8", "V8", "V8");
  static public final int V9_ = 86;
  static public final UnwindRegistersPPC64 V9 = new UnwindRegistersPPC64 (86, "UnwindRegistersPPC64_V9", "V9", "V9");
  static public final int V10_ = 87;
  static public final UnwindRegistersPPC64 V10 = new UnwindRegistersPPC64 (87, "UnwindRegistersPPC64_V10", "V10", "V10");
  static public final int V11_ = 88;
  static public final UnwindRegistersPPC64 V11 = new UnwindRegistersPPC64 (88, "UnwindRegistersPPC64_V11", "V11", "V11");
  static public final int V12_ = 89;
  static public final UnwindRegistersPPC64 V12 = new UnwindRegistersPPC64 (89, "UnwindRegistersPPC64_V12", "V12", "V12");
  static public final int V13_ = 90;
  static public final UnwindRegistersPPC64 V13 = new UnwindRegistersPPC64 (90, "UnwindRegistersPPC64_V13", "V13", "V13");
  static public final int V14_ = 91;
  static public final UnwindRegistersPPC64 V14 = new UnwindRegistersPPC64 (91, "UnwindRegistersPPC64_V14", "V14", "V14");
  static public final int V15_ = 92;
  static public final UnwindRegistersPPC64 V15 = new UnwindRegistersPPC64 (92, "UnwindRegistersPPC64_V15", "V15", "V15");
  static public final int V16_ = 93;
  static public final UnwindRegistersPPC64 V16 = new UnwindRegistersPPC64 (93, "UnwindRegistersPPC64_V16", "V16", "V16");
  static public final int V17_ = 94;
  static public final UnwindRegistersPPC64 V17 = new UnwindRegistersPPC64 (94, "UnwindRegistersPPC64_V17", "V17", "V17");
  static public final int V18_ = 95;
  static public final UnwindRegistersPPC64 V18 = new UnwindRegistersPPC64 (95, "UnwindRegistersPPC64_V18", "V18", "V18");
  static public final int V19_ = 96;
  static public final UnwindRegistersPPC64 V19 = new UnwindRegistersPPC64 (96, "UnwindRegistersPPC64_V19", "V19", "V19");
  static public final int V20_ = 97;
  static public final UnwindRegistersPPC64 V20 = new UnwindRegistersPPC64 (97, "UnwindRegistersPPC64_V20", "V20", "V20");
  static public final int V21_ = 98;
  static public final UnwindRegistersPPC64 V21 = new UnwindRegistersPPC64 (98, "UnwindRegistersPPC64_V21", "V21", "V21");
  static public final int V22_ = 99;
  static public final UnwindRegistersPPC64 V22 = new UnwindRegistersPPC64 (99, "UnwindRegistersPPC64_V22", "V22", "V22");
  static public final int V23_ = 100;
  static public final UnwindRegistersPPC64 V23 = new UnwindRegistersPPC64 (100, "UnwindRegistersPPC64_V23", "V23", "V23");
  static public final int V24_ = 101;
  static public final UnwindRegistersPPC64 V24 = new UnwindRegistersPPC64 (101, "UnwindRegistersPPC64_V24", "V24", "V24");
  static public final int V25_ = 102;
  static public final UnwindRegistersPPC64 V25 = new UnwindRegistersPPC64 (102, "UnwindRegistersPPC64_V25", "V25", "V25");
  static public final int V26_ = 103;
  static public final UnwindRegistersPPC64 V26 = new UnwindRegistersPPC64 (103, "UnwindRegistersPPC64_V26", "V26", "V26");
  static public final int V27_ = 104;
  static public final UnwindRegistersPPC64 V27 = new UnwindRegistersPPC64 (104, "UnwindRegistersPPC64_V27", "V27", "V27");
  static public final int V28_ = 105;
  static public final UnwindRegistersPPC64 V28 = new UnwindRegistersPPC64 (105, "UnwindRegistersPPC64_V28", "V28", "V28");
  static public final int V29_ = 106;
  static public final UnwindRegistersPPC64 V29 = new UnwindRegistersPPC64 (106, "UnwindRegistersPPC64_V29", "V29", "V29");
  static public final int V30_ = 107;
  static public final UnwindRegistersPPC64 V30 = new UnwindRegistersPPC64 (107, "UnwindRegistersPPC64_V30", "V30", "V30");
  static public final int V31_ = 108;
  static public final UnwindRegistersPPC64 V31 = new UnwindRegistersPPC64 (108, "UnwindRegistersPPC64_V31", "V31", "V31");
  static public final int VRSAVE_ = 109;
  static public final UnwindRegistersPPC64 VRSAVE = new UnwindRegistersPPC64 (109, "UnwindRegistersPPC64_VRSAVE", "VRSAVE", "VRSAVE");
  static public final int VSCR_ = 110;
  static public final UnwindRegistersPPC64 VSCR = new UnwindRegistersPPC64 (110, "UnwindRegistersPPC64_VSCR", "VSCR", "VSCR");
  static public final int SPE_ACC_ = 111;
  static public final UnwindRegistersPPC64 SPE_ACC = new UnwindRegistersPPC64 (111, "UnwindRegistersPPC64_SPE_ACC", "SPE ACC", "SPE_ACC");
  static public final int SPEFSCR_ = 112;
  static public final UnwindRegistersPPC64 SPEFSCR = new UnwindRegistersPPC64 (112, "UnwindRegistersPPC64_SPEFSCR", "SPEFSCR", "SPEFSCR");
  static public final int FRAME_POINTER_ = 113;
  static public final UnwindRegistersPPC64 FRAME_POINTER = new UnwindRegistersPPC64 (113, "UnwindRegistersPPC64_FRAME_POINTER", "FRAME POINTER", "FRAME_POINTER");
  static public final int NIP_ = 114;
  static public final UnwindRegistersPPC64 NIP = new UnwindRegistersPPC64 (114, "UnwindRegistersPPC64_NIP", "NIP", "NIP");

  /** Create a HashMap containing all the UnwindRegistersPPC64 elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (R0.enumName, R0);
    map.put (R1.enumName, R1);
    map.put (R2.enumName, R2);
    map.put (R3.enumName, R3);
    map.put (R4.enumName, R4);
    map.put (R5.enumName, R5);
    map.put (R6.enumName, R6);
    map.put (R7.enumName, R7);
    map.put (R8.enumName, R8);
    map.put (R9.enumName, R9);
    map.put (R10.enumName, R10);
    map.put (R11.enumName, R11);
    map.put (R12.enumName, R12);
    map.put (R13.enumName, R13);
    map.put (R14.enumName, R14);
    map.put (R15.enumName, R15);
    map.put (R16.enumName, R16);
    map.put (R17.enumName, R17);
    map.put (R18.enumName, R18);
    map.put (R19.enumName, R19);
    map.put (R20.enumName, R20);
    map.put (R21.enumName, R21);
    map.put (R22.enumName, R22);
    map.put (R23.enumName, R23);
    map.put (R24.enumName, R24);
    map.put (R25.enumName, R25);
    map.put (R26.enumName, R26);
    map.put (R27.enumName, R27);
    map.put (R28.enumName, R28);
    map.put (R29.enumName, R29);
    map.put (R30.enumName, R30);
    map.put (R31.enumName, R31);
    map.put (F0.enumName, F0);
    map.put (F1.enumName, F1);
    map.put (F2.enumName, F2);
    map.put (F3.enumName, F3);
    map.put (F4.enumName, F4);
    map.put (F5.enumName, F5);
    map.put (F6.enumName, F6);
    map.put (F7.enumName, F7);
    map.put (F8.enumName, F8);
    map.put (F9.enumName, F9);
    map.put (F10.enumName, F10);
    map.put (F11.enumName, F11);
    map.put (F12.enumName, F12);
    map.put (F13.enumName, F13);
    map.put (F14.enumName, F14);
    map.put (F15.enumName, F15);
    map.put (F16.enumName, F16);
    map.put (F17.enumName, F17);
    map.put (F18.enumName, F18);
    map.put (F19.enumName, F19);
    map.put (F20.enumName, F20);
    map.put (F21.enumName, F21);
    map.put (F22.enumName, F22);
    map.put (F23.enumName, F23);
    map.put (F24.enumName, F24);
    map.put (F25.enumName, F25);
    map.put (F26.enumName, F26);
    map.put (F27.enumName, F27);
    map.put (F28.enumName, F28);
    map.put (F29.enumName, F29);
    map.put (F30.enumName, F30);
    map.put (F31.enumName, F31);
    map.put (LR.enumName, LR);
    map.put (CTR.enumName, CTR);
    map.put (ARG_POINTER.enumName, ARG_POINTER);
    map.put (CR0.enumName, CR0);
    map.put (CR1.enumName, CR1);
    map.put (CR2.enumName, CR2);
    map.put (CR3.enumName, CR3);
    map.put (CR4.enumName, CR4);
    map.put (CR5.enumName, CR5);
    map.put (CR6.enumName, CR6);
    map.put (CR7.enumName, CR7);
    map.put (XER.enumName, XER);
    map.put (V0.enumName, V0);
    map.put (V1.enumName, V1);
    map.put (V2.enumName, V2);
    map.put (V3.enumName, V3);
    map.put (V4.enumName, V4);
    map.put (V5.enumName, V5);
    map.put (V6.enumName, V6);
    map.put (V7.enumName, V7);
    map.put (V8.enumName, V8);
    map.put (V9.enumName, V9);
    map.put (V10.enumName, V10);
    map.put (V11.enumName, V11);
    map.put (V12.enumName, V12);
    map.put (V13.enumName, V13);
    map.put (V14.enumName, V14);
    map.put (V15.enumName, V15);
    map.put (V16.enumName, V16);
    map.put (V17.enumName, V17);
    map.put (V18.enumName, V18);
    map.put (V19.enumName, V19);
    map.put (V20.enumName, V20);
    map.put (V21.enumName, V21);
    map.put (V22.enumName, V22);
    map.put (V23.enumName, V23);
    map.put (V24.enumName, V24);
    map.put (V25.enumName, V25);
    map.put (V26.enumName, V26);
    map.put (V27.enumName, V27);
    map.put (V28.enumName, V28);
    map.put (V29.enumName, V29);
    map.put (V30.enumName, V30);
    map.put (V31.enumName, V31);
    map.put (VRSAVE.enumName, VRSAVE);
    map.put (VSCR.enumName, VSCR);
    map.put (SPE_ACC.enumName, SPE_ACC);
    map.put (SPEFSCR.enumName, SPEFSCR);
    map.put (FRAME_POINTER.enumName, FRAME_POINTER);
    map.put (NIP.enumName, NIP);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the UnwindRegistersPPC64 object that matches the string.  */
  public static UnwindRegistersPPC64 valueOf (String string)
  {
    return (UnwindRegistersPPC64)enumMap.get (string);
  }

  /** Return the UnwindRegistersPPC64 object that matches the integer.  */
  public static UnwindRegistersPPC64 valueOf (long i)
  {
    switch ((int)i) {
    case R0_: return R0;
    case R1_: return R1;
    case R2_: return R2;
    case R3_: return R3;
    case R4_: return R4;
    case R5_: return R5;
    case R6_: return R6;
    case R7_: return R7;
    case R8_: return R8;
    case R9_: return R9;
    case R10_: return R10;
    case R11_: return R11;
    case R12_: return R12;
    case R13_: return R13;
    case R14_: return R14;
    case R15_: return R15;
    case R16_: return R16;
    case R17_: return R17;
    case R18_: return R18;
    case R19_: return R19;
    case R20_: return R20;
    case R21_: return R21;
    case R22_: return R22;
    case R23_: return R23;
    case R24_: return R24;
    case R25_: return R25;
    case R26_: return R26;
    case R27_: return R27;
    case R28_: return R28;
    case R29_: return R29;
    case R30_: return R30;
    case R31_: return R31;
    case F0_: return F0;
    case F1_: return F1;
    case F2_: return F2;
    case F3_: return F3;
    case F4_: return F4;
    case F5_: return F5;
    case F6_: return F6;
    case F7_: return F7;
    case F8_: return F8;
    case F9_: return F9;
    case F10_: return F10;
    case F11_: return F11;
    case F12_: return F12;
    case F13_: return F13;
    case F14_: return F14;
    case F15_: return F15;
    case F16_: return F16;
    case F17_: return F17;
    case F18_: return F18;
    case F19_: return F19;
    case F20_: return F20;
    case F21_: return F21;
    case F22_: return F22;
    case F23_: return F23;
    case F24_: return F24;
    case F25_: return F25;
    case F26_: return F26;
    case F27_: return F27;
    case F28_: return F28;
    case F29_: return F29;
    case F30_: return F30;
    case F31_: return F31;
    case LR_: return LR;
    case CTR_: return CTR;
    case ARG_POINTER_: return ARG_POINTER;
    case CR0_: return CR0;
    case CR1_: return CR1;
    case CR2_: return CR2;
    case CR3_: return CR3;
    case CR4_: return CR4;
    case CR5_: return CR5;
    case CR6_: return CR6;
    case CR7_: return CR7;
    case XER_: return XER;
    case V0_: return V0;
    case V1_: return V1;
    case V2_: return V2;
    case V3_: return V3;
    case V4_: return V4;
    case V5_: return V5;
    case V6_: return V6;
    case V7_: return V7;
    case V8_: return V8;
    case V9_: return V9;
    case V10_: return V10;
    case V11_: return V11;
    case V12_: return V12;
    case V13_: return V13;
    case V14_: return V14;
    case V15_: return V15;
    case V16_: return V16;
    case V17_: return V17;
    case V18_: return V18;
    case V19_: return V19;
    case V20_: return V20;
    case V21_: return V21;
    case V22_: return V22;
    case V23_: return V23;
    case V24_: return V24;
    case V25_: return V25;
    case V26_: return V26;
    case V27_: return V27;
    case V28_: return V28;
    case V29_: return V29;
    case V30_: return V30;
    case V31_: return V31;
    case VRSAVE_: return VRSAVE;
    case VSCR_: return VSCR;
    case SPE_ACC_: return SPE_ACC;
    case SPEFSCR_: return SPEFSCR;
    case FRAME_POINTER_: return FRAME_POINTER;
    case NIP_: return NIP;
    default: return null;
    }
  }

  /** Return an array of all the UnwindRegistersPPC64 elements.  */
  public static UnwindRegistersPPC64[] values ()
  {
    return (UnwindRegistersPPC64[]) enumMap.values ().toArray (new UnwindRegistersPPC64[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    UnwindRegistersPPC64 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    UnwindRegistersPPC64 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    UnwindRegistersPPC64 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    UnwindRegistersPPC64 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    UnwindRegistersPPC64 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
