package lib.unwind;

public class UnwindRegistersX86
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private UnwindRegistersX86 (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof UnwindRegistersX86))
      return false;
    return ((UnwindRegistersX86)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    UnwindRegistersX86 rhs = (UnwindRegistersX86) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int EAX_ = 0;
  static public final UnwindRegistersX86 EAX = new UnwindRegistersX86 (0, "UnwindRegistersX86_EAX", "EAX", "EAX");
  static public final int EDX_ = 1;
  static public final UnwindRegistersX86 EDX = new UnwindRegistersX86 (1, "UnwindRegistersX86_EDX", "EDX", "EDX");
  static public final int ECX_ = 2;
  static public final UnwindRegistersX86 ECX = new UnwindRegistersX86 (2, "UnwindRegistersX86_ECX", "ECX", "ECX");
  static public final int EBX_ = 3;
  static public final UnwindRegistersX86 EBX = new UnwindRegistersX86 (3, "UnwindRegistersX86_EBX", "EBX", "EBX");
  static public final int ESI_ = 4;
  static public final UnwindRegistersX86 ESI = new UnwindRegistersX86 (4, "UnwindRegistersX86_ESI", "ESI", "ESI");
  static public final int EDI_ = 5;
  static public final UnwindRegistersX86 EDI = new UnwindRegistersX86 (5, "UnwindRegistersX86_EDI", "EDI", "EDI");
  static public final int EBP_ = 6;
  static public final UnwindRegistersX86 EBP = new UnwindRegistersX86 (6, "UnwindRegistersX86_EBP", "EBP", "EBP");
  static public final int ESP_ = 7;
  static public final UnwindRegistersX86 ESP = new UnwindRegistersX86 (7, "UnwindRegistersX86_ESP", "ESP", "ESP");
  static public final int EIP_ = 8;
  static public final UnwindRegistersX86 EIP = new UnwindRegistersX86 (8, "UnwindRegistersX86_EIP", "EIP", "EIP");
  static public final int EFLAGS_ = 9;
  static public final UnwindRegistersX86 EFLAGS = new UnwindRegistersX86 (9, "UnwindRegistersX86_EFLAGS", "EFLAGS", "EFLAGS");
  static public final int TRAPNO_ = 10;
  static public final UnwindRegistersX86 TRAPNO = new UnwindRegistersX86 (10, "UnwindRegistersX86_TRAPNO", "TRAPNO", "TRAPNO");
  static public final int ST0_ = 11;
  static public final UnwindRegistersX86 ST0 = new UnwindRegistersX86 (11, "UnwindRegistersX86_ST0", "ST0", "ST0");
  static public final int ST1_ = 12;
  static public final UnwindRegistersX86 ST1 = new UnwindRegistersX86 (12, "UnwindRegistersX86_ST1", "ST1", "ST1");
  static public final int ST2_ = 13;
  static public final UnwindRegistersX86 ST2 = new UnwindRegistersX86 (13, "UnwindRegistersX86_ST2", "ST2", "ST2");
  static public final int ST3_ = 14;
  static public final UnwindRegistersX86 ST3 = new UnwindRegistersX86 (14, "UnwindRegistersX86_ST3", "ST3", "ST3");
  static public final int ST4_ = 15;
  static public final UnwindRegistersX86 ST4 = new UnwindRegistersX86 (15, "UnwindRegistersX86_ST4", "ST4", "ST4");
  static public final int ST5_ = 16;
  static public final UnwindRegistersX86 ST5 = new UnwindRegistersX86 (16, "UnwindRegistersX86_ST5", "ST5", "ST5");
  static public final int ST6_ = 17;
  static public final UnwindRegistersX86 ST6 = new UnwindRegistersX86 (17, "UnwindRegistersX86_ST6", "ST6", "ST6");
  static public final int ST7_ = 18;
  static public final UnwindRegistersX86 ST7 = new UnwindRegistersX86 (18, "UnwindRegistersX86_ST7", "ST7", "ST7");
  static public final int FCW_ = 19;
  static public final UnwindRegistersX86 FCW = new UnwindRegistersX86 (19, "UnwindRegistersX86_FCW", "FCW", "FCW");
  static public final int FSW_ = 20;
  static public final UnwindRegistersX86 FSW = new UnwindRegistersX86 (20, "UnwindRegistersX86_FSW", "FSW", "FSW");
  static public final int FTW_ = 21;
  static public final UnwindRegistersX86 FTW = new UnwindRegistersX86 (21, "UnwindRegistersX86_FTW", "FTW", "FTW");
  static public final int FOP_ = 22;
  static public final UnwindRegistersX86 FOP = new UnwindRegistersX86 (22, "UnwindRegistersX86_FOP", "FOP", "FOP");
  static public final int FCS_ = 23;
  static public final UnwindRegistersX86 FCS = new UnwindRegistersX86 (23, "UnwindRegistersX86_FCS", "FCS", "FCS");
  static public final int FIP_ = 24;
  static public final UnwindRegistersX86 FIP = new UnwindRegistersX86 (24, "UnwindRegistersX86_FIP", "FIP", "FIP");
  static public final int FEA_ = 25;
  static public final UnwindRegistersX86 FEA = new UnwindRegistersX86 (25, "UnwindRegistersX86_FEA", "FEA", "FEA");
  static public final int FDS_ = 26;
  static public final UnwindRegistersX86 FDS = new UnwindRegistersX86 (26, "UnwindRegistersX86_FDS", "FDS", "FDS");
  static public final int XMM0_lo_ = 27;
  static public final UnwindRegistersX86 XMM0_lo = new UnwindRegistersX86 (27, "UnwindRegistersX86_XMM0_lo", "XMM0 lo", "XMM0_lo");
  static public final int XMM0_hi_ = 28;
  static public final UnwindRegistersX86 XMM0_hi = new UnwindRegistersX86 (28, "UnwindRegistersX86_XMM0_hi", "XMM0 hi", "XMM0_hi");
  static public final int XMM1_lo_ = 29;
  static public final UnwindRegistersX86 XMM1_lo = new UnwindRegistersX86 (29, "UnwindRegistersX86_XMM1_lo", "XMM1 lo", "XMM1_lo");
  static public final int XMM1_hi_ = 30;
  static public final UnwindRegistersX86 XMM1_hi = new UnwindRegistersX86 (30, "UnwindRegistersX86_XMM1_hi", "XMM1 hi", "XMM1_hi");
  static public final int XMM2_lo_ = 31;
  static public final UnwindRegistersX86 XMM2_lo = new UnwindRegistersX86 (31, "UnwindRegistersX86_XMM2_lo", "XMM2 lo", "XMM2_lo");
  static public final int XMM2_hi_ = 32;
  static public final UnwindRegistersX86 XMM2_hi = new UnwindRegistersX86 (32, "UnwindRegistersX86_XMM2_hi", "XMM2 hi", "XMM2_hi");
  static public final int XMM3_lo_ = 33;
  static public final UnwindRegistersX86 XMM3_lo = new UnwindRegistersX86 (33, "UnwindRegistersX86_XMM3_lo", "XMM3 lo", "XMM3_lo");
  static public final int XMM3_hi_ = 34;
  static public final UnwindRegistersX86 XMM3_hi = new UnwindRegistersX86 (34, "UnwindRegistersX86_XMM3_hi", "XMM3 hi", "XMM3_hi");
  static public final int XMM4_lo_ = 35;
  static public final UnwindRegistersX86 XMM4_lo = new UnwindRegistersX86 (35, "UnwindRegistersX86_XMM4_lo", "XMM4 lo", "XMM4_lo");
  static public final int XMM4_hi_ = 36;
  static public final UnwindRegistersX86 XMM4_hi = new UnwindRegistersX86 (36, "UnwindRegistersX86_XMM4_hi", "XMM4 hi", "XMM4_hi");
  static public final int XMM5_lo_ = 37;
  static public final UnwindRegistersX86 XMM5_lo = new UnwindRegistersX86 (37, "UnwindRegistersX86_XMM5_lo", "XMM5 lo", "XMM5_lo");
  static public final int XMM5_hi_ = 38;
  static public final UnwindRegistersX86 XMM5_hi = new UnwindRegistersX86 (38, "UnwindRegistersX86_XMM5_hi", "XMM5 hi", "XMM5_hi");
  static public final int XMM6_lo_ = 39;
  static public final UnwindRegistersX86 XMM6_lo = new UnwindRegistersX86 (39, "UnwindRegistersX86_XMM6_lo", "XMM6 lo", "XMM6_lo");
  static public final int XMM6_hi_ = 40;
  static public final UnwindRegistersX86 XMM6_hi = new UnwindRegistersX86 (40, "UnwindRegistersX86_XMM6_hi", "XMM6 hi", "XMM6_hi");
  static public final int XMM7_lo_ = 41;
  static public final UnwindRegistersX86 XMM7_lo = new UnwindRegistersX86 (41, "UnwindRegistersX86_XMM7_lo", "XMM7 lo", "XMM7_lo");
  static public final int XMM7_hi_ = 42;
  static public final UnwindRegistersX86 XMM7_hi = new UnwindRegistersX86 (42, "UnwindRegistersX86_XMM7_hi", "XMM7 hi", "XMM7_hi");
  static public final int MXCSR_ = 43;
  static public final UnwindRegistersX86 MXCSR = new UnwindRegistersX86 (43, "UnwindRegistersX86_MXCSR", "MXCSR", "MXCSR");
  static public final int GS_ = 44;
  static public final UnwindRegistersX86 GS = new UnwindRegistersX86 (44, "UnwindRegistersX86_GS", "GS", "GS");
  static public final int FS_ = 45;
  static public final UnwindRegistersX86 FS = new UnwindRegistersX86 (45, "UnwindRegistersX86_FS", "FS", "FS");
  static public final int ES_ = 46;
  static public final UnwindRegistersX86 ES = new UnwindRegistersX86 (46, "UnwindRegistersX86_ES", "ES", "ES");
  static public final int DS_ = 47;
  static public final UnwindRegistersX86 DS = new UnwindRegistersX86 (47, "UnwindRegistersX86_DS", "DS", "DS");
  static public final int SS_ = 48;
  static public final UnwindRegistersX86 SS = new UnwindRegistersX86 (48, "UnwindRegistersX86_SS", "SS", "SS");
  static public final int CS_ = 49;
  static public final UnwindRegistersX86 CS = new UnwindRegistersX86 (49, "UnwindRegistersX86_CS", "CS", "CS");
  static public final int TSS_ = 50;
  static public final UnwindRegistersX86 TSS = new UnwindRegistersX86 (50, "UnwindRegistersX86_TSS", "TSS", "TSS");
  static public final int LDT_ = 51;
  static public final UnwindRegistersX86 LDT = new UnwindRegistersX86 (51, "UnwindRegistersX86_LDT", "LDT", "LDT");
  static public final int CFA_ = 52;
  static public final UnwindRegistersX86 CFA = new UnwindRegistersX86 (52, "UnwindRegistersX86_CFA", "CFA", "CFA");
  static public final int XMM0_ = 53;
  static public final UnwindRegistersX86 XMM0 = new UnwindRegistersX86 (53, "UnwindRegistersX86_XMM0", "XMM0", "XMM0");
  static public final int XMM1_ = 54;
  static public final UnwindRegistersX86 XMM1 = new UnwindRegistersX86 (54, "UnwindRegistersX86_XMM1", "XMM1", "XMM1");
  static public final int XMM2_ = 55;
  static public final UnwindRegistersX86 XMM2 = new UnwindRegistersX86 (55, "UnwindRegistersX86_XMM2", "XMM2", "XMM2");
  static public final int XMM3_ = 56;
  static public final UnwindRegistersX86 XMM3 = new UnwindRegistersX86 (56, "UnwindRegistersX86_XMM3", "XMM3", "XMM3");
  static public final int XMM4_ = 57;
  static public final UnwindRegistersX86 XMM4 = new UnwindRegistersX86 (57, "UnwindRegistersX86_XMM4", "XMM4", "XMM4");
  static public final int XMM5_ = 58;
  static public final UnwindRegistersX86 XMM5 = new UnwindRegistersX86 (58, "UnwindRegistersX86_XMM5", "XMM5", "XMM5");
  static public final int XMM6_ = 59;
  static public final UnwindRegistersX86 XMM6 = new UnwindRegistersX86 (59, "UnwindRegistersX86_XMM6", "XMM6", "XMM6");
  static public final int XMM7_ = 60;
  static public final UnwindRegistersX86 XMM7 = new UnwindRegistersX86 (60, "UnwindRegistersX86_XMM7", "XMM7", "XMM7");
  static public final int UNW_TDEP_LAST_REG_ = 61;
  static public final UnwindRegistersX86 UNW_TDEP_LAST_REG = new UnwindRegistersX86 (61, "UnwindRegistersX86_UNW_TDEP_LAST_REG", "UNW TDEP LAST REG", "UNW_TDEP_LAST_REG");
  static public final int UNW_TDEP_IP_ = 62;
  static public final UnwindRegistersX86 UNW_TDEP_IP = new UnwindRegistersX86 (62, "UnwindRegistersX86_UNW_TDEP_IP", "UNW TDEP IP", "UNW_TDEP_IP");
  static public final int UNW_TDEP_SP_ = 63;
  static public final UnwindRegistersX86 UNW_TDEP_SP = new UnwindRegistersX86 (63, "UnwindRegistersX86_UNW_TDEP_SP", "UNW TDEP SP", "UNW_TDEP_SP");
  static public final int UNW_TDEP_EH_ = 64;
  static public final UnwindRegistersX86 UNW_TDEP_EH = new UnwindRegistersX86 (64, "UnwindRegistersX86_UNW_TDEP_EH", "UNW TDEP EH", "UNW_TDEP_EH");

  /** Create a HashMap containing all the UnwindRegistersX86 elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (EAX.enumName, EAX);
    map.put (EDX.enumName, EDX);
    map.put (ECX.enumName, ECX);
    map.put (EBX.enumName, EBX);
    map.put (ESI.enumName, ESI);
    map.put (EDI.enumName, EDI);
    map.put (EBP.enumName, EBP);
    map.put (ESP.enumName, ESP);
    map.put (EIP.enumName, EIP);
    map.put (EFLAGS.enumName, EFLAGS);
    map.put (TRAPNO.enumName, TRAPNO);
    map.put (ST0.enumName, ST0);
    map.put (ST1.enumName, ST1);
    map.put (ST2.enumName, ST2);
    map.put (ST3.enumName, ST3);
    map.put (ST4.enumName, ST4);
    map.put (ST5.enumName, ST5);
    map.put (ST6.enumName, ST6);
    map.put (ST7.enumName, ST7);
    map.put (FCW.enumName, FCW);
    map.put (FSW.enumName, FSW);
    map.put (FTW.enumName, FTW);
    map.put (FOP.enumName, FOP);
    map.put (FCS.enumName, FCS);
    map.put (FIP.enumName, FIP);
    map.put (FEA.enumName, FEA);
    map.put (FDS.enumName, FDS);
    map.put (XMM0_lo.enumName, XMM0_lo);
    map.put (XMM0_hi.enumName, XMM0_hi);
    map.put (XMM1_lo.enumName, XMM1_lo);
    map.put (XMM1_hi.enumName, XMM1_hi);
    map.put (XMM2_lo.enumName, XMM2_lo);
    map.put (XMM2_hi.enumName, XMM2_hi);
    map.put (XMM3_lo.enumName, XMM3_lo);
    map.put (XMM3_hi.enumName, XMM3_hi);
    map.put (XMM4_lo.enumName, XMM4_lo);
    map.put (XMM4_hi.enumName, XMM4_hi);
    map.put (XMM5_lo.enumName, XMM5_lo);
    map.put (XMM5_hi.enumName, XMM5_hi);
    map.put (XMM6_lo.enumName, XMM6_lo);
    map.put (XMM6_hi.enumName, XMM6_hi);
    map.put (XMM7_lo.enumName, XMM7_lo);
    map.put (XMM7_hi.enumName, XMM7_hi);
    map.put (MXCSR.enumName, MXCSR);
    map.put (GS.enumName, GS);
    map.put (FS.enumName, FS);
    map.put (ES.enumName, ES);
    map.put (DS.enumName, DS);
    map.put (SS.enumName, SS);
    map.put (CS.enumName, CS);
    map.put (TSS.enumName, TSS);
    map.put (LDT.enumName, LDT);
    map.put (CFA.enumName, CFA);
    map.put (XMM0.enumName, XMM0);
    map.put (XMM1.enumName, XMM1);
    map.put (XMM2.enumName, XMM2);
    map.put (XMM3.enumName, XMM3);
    map.put (XMM4.enumName, XMM4);
    map.put (XMM5.enumName, XMM5);
    map.put (XMM6.enumName, XMM6);
    map.put (XMM7.enumName, XMM7);
    map.put (UNW_TDEP_LAST_REG.enumName, UNW_TDEP_LAST_REG);
    map.put (UNW_TDEP_IP.enumName, UNW_TDEP_IP);
    map.put (UNW_TDEP_SP.enumName, UNW_TDEP_SP);
    map.put (UNW_TDEP_EH.enumName, UNW_TDEP_EH);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the UnwindRegistersX86 object that matches the string.  */
  public static UnwindRegistersX86 valueOf (String string)
  {
    return (UnwindRegistersX86)enumMap.get (string);
  }

  /** Return the UnwindRegistersX86 object that matches the integer.  */
  public static UnwindRegistersX86 valueOf (long i)
  {
    switch ((int)i) {
    case EAX_: return EAX;
    case EDX_: return EDX;
    case ECX_: return ECX;
    case EBX_: return EBX;
    case ESI_: return ESI;
    case EDI_: return EDI;
    case EBP_: return EBP;
    case ESP_: return ESP;
    case EIP_: return EIP;
    case EFLAGS_: return EFLAGS;
    case TRAPNO_: return TRAPNO;
    case ST0_: return ST0;
    case ST1_: return ST1;
    case ST2_: return ST2;
    case ST3_: return ST3;
    case ST4_: return ST4;
    case ST5_: return ST5;
    case ST6_: return ST6;
    case ST7_: return ST7;
    case FCW_: return FCW;
    case FSW_: return FSW;
    case FTW_: return FTW;
    case FOP_: return FOP;
    case FCS_: return FCS;
    case FIP_: return FIP;
    case FEA_: return FEA;
    case FDS_: return FDS;
    case XMM0_lo_: return XMM0_lo;
    case XMM0_hi_: return XMM0_hi;
    case XMM1_lo_: return XMM1_lo;
    case XMM1_hi_: return XMM1_hi;
    case XMM2_lo_: return XMM2_lo;
    case XMM2_hi_: return XMM2_hi;
    case XMM3_lo_: return XMM3_lo;
    case XMM3_hi_: return XMM3_hi;
    case XMM4_lo_: return XMM4_lo;
    case XMM4_hi_: return XMM4_hi;
    case XMM5_lo_: return XMM5_lo;
    case XMM5_hi_: return XMM5_hi;
    case XMM6_lo_: return XMM6_lo;
    case XMM6_hi_: return XMM6_hi;
    case XMM7_lo_: return XMM7_lo;
    case XMM7_hi_: return XMM7_hi;
    case MXCSR_: return MXCSR;
    case GS_: return GS;
    case FS_: return FS;
    case ES_: return ES;
    case DS_: return DS;
    case SS_: return SS;
    case CS_: return CS;
    case TSS_: return TSS;
    case LDT_: return LDT;
    case CFA_: return CFA;
    case XMM0_: return XMM0;
    case XMM1_: return XMM1;
    case XMM2_: return XMM2;
    case XMM3_: return XMM3;
    case XMM4_: return XMM4;
    case XMM5_: return XMM5;
    case XMM6_: return XMM6;
    case XMM7_: return XMM7;
    case UNW_TDEP_LAST_REG_: return UNW_TDEP_LAST_REG;
    case UNW_TDEP_IP_: return UNW_TDEP_IP;
    case UNW_TDEP_SP_: return UNW_TDEP_SP;
    case UNW_TDEP_EH_: return UNW_TDEP_EH;
    default: return null;
    }
  }

  /** Return an array of all the UnwindRegistersX86 elements.  */
  public static UnwindRegistersX86[] values ()
  {
    return (UnwindRegistersX86[]) enumMap.values ().toArray (new UnwindRegistersX86[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    UnwindRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    UnwindRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    UnwindRegistersX86 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    UnwindRegistersX86 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    UnwindRegistersX86 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
