package lib.unwind;

public class UnwindRegistersX8664
  extends Number
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private UnwindRegistersX8664 (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  /**
   * Return true if OBJECT has the same value.
   */
  public boolean equals (Object o)
  {
    if (o == null)
      return false;
    if (! (o instanceof UnwindRegistersX8664))
      return false;
    return ((UnwindRegistersX8664)o).intValue() == this.intValue();
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    UnwindRegistersX8664 rhs = (UnwindRegistersX8664) o; // Can throw - ok.
    return this.enumValue - rhs.enumValue;
  }
  static public final int RAX_ = 0;
  static public final UnwindRegistersX8664 RAX = new UnwindRegistersX8664 (0, "UnwindRegistersX8664_RAX", "RAX", "RAX");
  static public final int RDX_ = 1;
  static public final UnwindRegistersX8664 RDX = new UnwindRegistersX8664 (1, "UnwindRegistersX8664_RDX", "RDX", "RDX");
  static public final int RCX_ = 2;
  static public final UnwindRegistersX8664 RCX = new UnwindRegistersX8664 (2, "UnwindRegistersX8664_RCX", "RCX", "RCX");
  static public final int RBX_ = 3;
  static public final UnwindRegistersX8664 RBX = new UnwindRegistersX8664 (3, "UnwindRegistersX8664_RBX", "RBX", "RBX");
  static public final int RSI_ = 4;
  static public final UnwindRegistersX8664 RSI = new UnwindRegistersX8664 (4, "UnwindRegistersX8664_RSI", "RSI", "RSI");
  static public final int RDI_ = 5;
  static public final UnwindRegistersX8664 RDI = new UnwindRegistersX8664 (5, "UnwindRegistersX8664_RDI", "RDI", "RDI");
  static public final int RBP_ = 6;
  static public final UnwindRegistersX8664 RBP = new UnwindRegistersX8664 (6, "UnwindRegistersX8664_RBP", "RBP", "RBP");
  static public final int RSP_ = 7;
  static public final UnwindRegistersX8664 RSP = new UnwindRegistersX8664 (7, "UnwindRegistersX8664_RSP", "RSP", "RSP");
  static public final int R8_ = 8;
  static public final UnwindRegistersX8664 R8 = new UnwindRegistersX8664 (8, "UnwindRegistersX8664_R8", "R8", "R8");
  static public final int R9_ = 9;
  static public final UnwindRegistersX8664 R9 = new UnwindRegistersX8664 (9, "UnwindRegistersX8664_R9", "R9", "R9");
  static public final int R10_ = 10;
  static public final UnwindRegistersX8664 R10 = new UnwindRegistersX8664 (10, "UnwindRegistersX8664_R10", "R10", "R10");
  static public final int R11_ = 11;
  static public final UnwindRegistersX8664 R11 = new UnwindRegistersX8664 (11, "UnwindRegistersX8664_R11", "R11", "R11");
  static public final int R12_ = 12;
  static public final UnwindRegistersX8664 R12 = new UnwindRegistersX8664 (12, "UnwindRegistersX8664_R12", "R12", "R12");
  static public final int R13_ = 13;
  static public final UnwindRegistersX8664 R13 = new UnwindRegistersX8664 (13, "UnwindRegistersX8664_R13", "R13", "R13");
  static public final int R14_ = 14;
  static public final UnwindRegistersX8664 R14 = new UnwindRegistersX8664 (14, "UnwindRegistersX8664_R14", "R14", "R14");
  static public final int R15_ = 15;
  static public final UnwindRegistersX8664 R15 = new UnwindRegistersX8664 (15, "UnwindRegistersX8664_R15", "R15", "R15");
  static public final int RIP_ = 16;
  static public final UnwindRegistersX8664 RIP = new UnwindRegistersX8664 (16, "UnwindRegistersX8664_RIP", "RIP", "RIP");
  static public final int CFA_ = 17;
  static public final UnwindRegistersX8664 CFA = new UnwindRegistersX8664 (17, "UnwindRegistersX8664_CFA", "CFA", "CFA");
  static public final int UNW_TDEP_LAST_REG_ = 18;
  static public final UnwindRegistersX8664 UNW_TDEP_LAST_REG = new UnwindRegistersX8664 (18, "UnwindRegistersX8664_UNW_TDEP_LAST_REG", "UNW TDEP LAST REG", "UNW_TDEP_LAST_REG");
  static public final int UNW_TDEP_IP_ = 19;
  static public final UnwindRegistersX8664 UNW_TDEP_IP = new UnwindRegistersX8664 (19, "UnwindRegistersX8664_UNW_TDEP_IP", "UNW TDEP IP", "UNW_TDEP_IP");
  static public final int UNW_TDEP_SP_ = 20;
  static public final UnwindRegistersX8664 UNW_TDEP_SP = new UnwindRegistersX8664 (20, "UnwindRegistersX8664_UNW_TDEP_SP", "UNW TDEP SP", "UNW_TDEP_SP");
  static public final int UNW_TDEP_BP_ = 21;
  static public final UnwindRegistersX8664 UNW_TDEP_BP = new UnwindRegistersX8664 (21, "UnwindRegistersX8664_UNW_TDEP_BP", "UNW TDEP BP", "UNW_TDEP_BP");
  static public final int UNW_TDEP_EH_ = 22;
  static public final UnwindRegistersX8664 UNW_TDEP_EH = new UnwindRegistersX8664 (22, "UnwindRegistersX8664_UNW_TDEP_EH", "UNW TDEP EH", "UNW_TDEP_EH");

  /** Create a HashMap containing all the UnwindRegistersX8664 elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (RAX.enumName, RAX);
    map.put (RDX.enumName, RDX);
    map.put (RCX.enumName, RCX);
    map.put (RBX.enumName, RBX);
    map.put (RSI.enumName, RSI);
    map.put (RDI.enumName, RDI);
    map.put (RBP.enumName, RBP);
    map.put (RSP.enumName, RSP);
    map.put (R8.enumName, R8);
    map.put (R9.enumName, R9);
    map.put (R10.enumName, R10);
    map.put (R11.enumName, R11);
    map.put (R12.enumName, R12);
    map.put (R13.enumName, R13);
    map.put (R14.enumName, R14);
    map.put (R15.enumName, R15);
    map.put (RIP.enumName, RIP);
    map.put (CFA.enumName, CFA);
    map.put (UNW_TDEP_LAST_REG.enumName, UNW_TDEP_LAST_REG);
    map.put (UNW_TDEP_IP.enumName, UNW_TDEP_IP);
    map.put (UNW_TDEP_SP.enumName, UNW_TDEP_SP);
    map.put (UNW_TDEP_BP.enumName, UNW_TDEP_BP);
    map.put (UNW_TDEP_EH.enumName, UNW_TDEP_EH);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the UnwindRegistersX8664 object that matches the string.  */
  public static UnwindRegistersX8664 valueOf (String string)
  {
    return (UnwindRegistersX8664)enumMap.get (string);
  }

  /** Return the UnwindRegistersX8664 object that matches the integer.  */
  public static UnwindRegistersX8664 valueOf (long i)
  {
    switch ((int)i) {
    case RAX_: return RAX;
    case RDX_: return RDX;
    case RCX_: return RCX;
    case RBX_: return RBX;
    case RSI_: return RSI;
    case RDI_: return RDI;
    case RBP_: return RBP;
    case RSP_: return RSP;
    case R8_: return R8;
    case R9_: return R9;
    case R10_: return R10;
    case R11_: return R11;
    case R12_: return R12;
    case R13_: return R13;
    case R14_: return R14;
    case R15_: return R15;
    case RIP_: return RIP;
    case CFA_: return CFA;
    case UNW_TDEP_LAST_REG_: return UNW_TDEP_LAST_REG;
    case UNW_TDEP_IP_: return UNW_TDEP_IP;
    case UNW_TDEP_SP_: return UNW_TDEP_SP;
    case UNW_TDEP_BP_: return UNW_TDEP_BP;
    case UNW_TDEP_EH_: return UNW_TDEP_EH;
    default: return null;
    }
  }

  /** Return an array of all the UnwindRegistersX8664 elements.  */
  public static UnwindRegistersX8664[] values ()
  {
    return (UnwindRegistersX8664[]) enumMap.values ().toArray (new UnwindRegistersX8664[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    UnwindRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    UnwindRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    UnwindRegistersX8664 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    UnwindRegistersX8664 c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    UnwindRegistersX8664 c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }

  /**
   * Return the equivalent of the enum.
   */
  public int intValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public long longValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public float floatValue () {
    return enumValue;
  }

  /**
   * Return the equivalent of the enum.
   */
  public double doubleValue () {
    return enumValue;
  }

  static final long serialVersionUID = 0;
}
